/* File Cell.h  definition of class Cell */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#ifndef CELL_H
#define CELL_H

#include <rodin/server.h>

#include <rodin/evnthdlr.h>
#include "SimpleStore.h"
#include "Transport.h"
#include "Machine-Stub.h"
#include <oak/dictiona.h>

class Lot;
class Piece;






class CppWidget;

extern Symbol LotCompleted;


extern Class class_Cell;

class Cell : public Server
{
	DEFINE_CLASS_METHOD(Cell);
	DEFINE_IDLE_STORE_METHOD(Cell,Server);


  private:
	EventHandler ev;

  protected:
	SimpleStore storeOut;
	SimpleStore storeIn;
	Transport tr;
	Machine mac;
	Dictionary configurationData;
	Dictionary technologicalData;


  private:

  private:
	void fillStoreIn(Lot& lot);
	void emptyStoreOut();

	virtual Object* doService(Service* service);

  protected:


  public:
	Cell();
	Cell(Object* parentWidget);


	void waitLot(Lot* lot);
	void start();
	void stop();
	void waitSetup();
	void repair();
	void maintain();

	Object* editorTrace(String& member);

};

#endif /* CELL */
