/* File Machine-Stub.C  implementation of class Machine */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#define MACHINE_STUB_C

#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "Machine-Stub.h"





#include <oak/orderedc.h>
#include <rodin/service.h>
#include <oak/integer.h>


Symbol MacWaitWorkEmpty = "MacWaitWorkEmpty";
Symbol MacStartWork = "MacStartWork";
Symbol MacEndWork = "MacEndWork";
Symbol MacOutFull = "MacOutFull";

Symbol MacDoWork = "MacDoWork";
Symbol MacRemovePiece = "MacRemovePiece";



Symbol StubWaitEvent("StubWaitEvent");



DEFINE_SIMPLE_CLASS(Machine,Server,1,NULL);
#define THIS Machine
#define BASE Server


Machine::Machine(const char* name, int /*inputSize*/)
  :BASE(name), network(name)
{
}




Machine::~Machine()
{
  network.closeConnection();
  // assert(!ev.someAttach()); // forgot some detach
  // assert(size() == 0); // no more service run
}




Object* Machine::doService(Service* service)
{
  TRACE_FUNC("Machine::doService");
  CBACK_TRACE(service,"Machine-Stub_doService|_START_");
  
  ev.attachTo(&network,MessageReceived,service);
  Integer serviceId( (int)service );
  CBACK_TRACE(service,"Machine-Stub_doService|538140292");
  
  startService(service);
  CBACK_TRACE(service,"Machine-Stub_doService|2149856");
  while (YES)
  {
      CBACK_TRACE(service,"Machine-Stub_doService|538172036");
      service->setStatus(StubWaitEvent);
      CBACK_TRACE(service,"Machine-Stub_doService|538181380");
      
      ev.waitEvent(MessageReceived);
      Object* data = ev.callData();
      CBACK_TRACE(service,"Machine-Stub_doService|538198020");
      if( validObject(data) && data->isKindOf(class_OrderedCltn) )
      {
          CBACK_TRACE(service,"Machine-Stub_doService|538213124");
      }
      else
      {
          CBACK_TRACE(service,"Machine-Stub_doService|538213124");

          CBACK_TRACE(service,"Machine-Stub_doService|538213764");
          continue;
      }
      
      OrderedCltn& message = *CASTP(OrderedCltn,data);
      CBACK_TRACE(service,"Machine-Stub_doService|538245124");
      if( serviceId == *message[2] )
      {
          CBACK_TRACE(service,"Machine-Stub_doService|538212740");
      }
      else
      {
          CBACK_TRACE(service,"Machine-Stub_doService|538212740");

          CBACK_TRACE(service,"Machine-Stub_doService|538272772");
          continue;
      }
      
      Symbol sym = *CASTP(Symbol,message[1]);
      message.deleteAll();
      delete data;
      CBACK_TRACE(service,"Machine-Stub_doService|538286468");
      if( sym == ServiceTerminated )
      {
          CBACK_TRACE(service,"Machine-Stub_doService|538285316");

          CBACK_TRACE(service,"Machine-Stub_doService|538272900");
          break;
      }
      else
      {
          CBACK_TRACE(service,"Machine-Stub_doService|538285316");
          if( sym == ServiceRunning )
          {
              CBACK_TRACE(service,"Machine-Stub_doService|538297732");
          }
          else
          {
              CBACK_TRACE(service,"Machine-Stub_doService|538297732");
              
              signalService(service,sym);
              CBACK_TRACE(service,"Machine-Stub_doService|538316164");
          }
      }
  }
  
  ev.detachFrom(&network,MessageReceived,service);
  CBACK_TRACE(service,"Machine-Stub_doService|538321668");

  CBACK_TRACE(service,"Machine-Stub_doService|538110724");
  return stopService(service);
}



void Machine::startService(Service* service)
{
  TRACE_FUNC("Machine::startService");
  GET_ARG(0,Symbol,serviceKind);
  String execString = "exec" + String(serviceKind);
  Integer serviceId( (int)service );
  if(&serviceKind == &MacDoWork)
  {
  	GET_ARG(1,Piece,piece);
	String pieceName = piece.name();
  	String pieceType = piece.type();
  	GET_ARG(2,Symbol,partProg);
	network.sendCltnMsg(execString,&serviceId,
		&pieceName,&pieceType,&partProg);
	return;
  }
  else
  if(&serviceKind == &MacRemovePiece)
  {
	network.sendCltnMsg(execString,&serviceId);
	return;
  }
  assert(0);
}


void Machine::signalService(Service* service, Symbol& state)
{
  TRACE_FUNC("Machine::signalService");
  GET_ARG(0,Symbol,serviceKind);
  if(&serviceKind == &MacDoWork)
  {
  	GET_ARG(1,Piece,piece);
	service->setStatus(state,&piece);
	if(state == MacOutFull)
		pieceOut.add(piece);
	return;
  }
  else
  if(&serviceKind == &MacRemovePiece)
  {
	return;
  }
  assert(0);
}


Object* Machine::stopService(Service* service)
{
  TRACE_FUNC("Machine::stopService");
  GET_ARG(0,Symbol,serviceKind);
  if(&serviceKind == &MacDoWork)
  {
	return nil;
  }
  else
  if(&serviceKind == &MacRemovePiece)
  {
	return pieceOut.removeFirst();
  }
  assert(0);
  return nil;
}



Service* Machine::joinWork(Piece* piece, Symbol* partProgram)
{
  return joinService(&MacDoWork,piece,partProgram);
}


Piece* Machine::waitRemovePiece()
{
  return CASTP(Piece,waitService(&MacRemovePiece));
}




Object* Machine::editorTrace(String& s)
{
  if(s == "ev")
  {
	s = ev.printOnString();
	return (Object*)&ev;
  }
  else
  if(s == "network")
  {
	s = network.printOnString();
	return (Object*)&network;
  }
  else
  if(s == "pieceOut")
  {
	s = pieceOut.printOnString();
	return (Object*)&pieceOut;
  }
  return nil;
}

/* End of File MACHINE_STUB */

