/* File Machine-Stub.h  definition of class Machine */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#ifndef MACHINE_STUB_H
#define MACHINE_STUB_H

#include <rodin/server.h>

#include "Piece.h"
#include <oak/orderedc.h>
#include <rodin/evnthdlr.h>
#include "Network.h"





class Service;

extern Symbol MacWaitWorkEmpty;
extern Symbol MacStartWork;
extern Symbol MacEndWork;
extern Symbol MacOutFull;



extern Class class_Machine;

class Machine : public Server
{
	DEFINE_CLASS_METHOD(Machine);
	DEFINE_IDLE_STORE_METHOD(Machine,Server);


  private:
	EventHandler ev;
	Network network;

  protected:

	OrderedCltn pieceOut;

  private:
	virtual Object* doService(Service* service);

  protected:
	void startService(Service* service);
	void signalService(Service* service, Symbol& state);
	Object* stopService(Service* service);

  public:
	Machine(const char* name ="Stub", int /*inputSize*/ =1);
	~Machine();


	Service* joinWork(Piece* piece, Symbol* partProgram);
	Piece* waitRemovePiece();

	Object* editorTrace(String& member);

};

#endif /* MACHINE_STUB */

