/* File Network.C  implementation of class Network */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#define NETWORK_C

#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>
#include <mondrian/widget.h>

#include "Network.h"

#include "Tcpip.h"


#define THIS Network
#define BASE Object




#include <oak/orderedc.h>
// #include <mondrian/widget.h>

#if !defined(ultrix) & !defined(LYNXOS)
# include <strstream.h>
#endif

#if defined(IBM_RISC)
  CFUNC_BEGIN  
    extern int dup(int);
    // extern execl(const char*,const char*,...);
  CFUNC_END
#else
  CFUNC_BEGIN  
    extern int dup(int);
    extern execl(const char*,const char*,...);
  CFUNC_END
#endif

Symbol MessageReceived = "MessageReceived";
Symbol ConnectionClosed = "ConnectionClosed";


static void xInputFunc(caddr_t userData,int* /*recv*/, XtInputId* fileId)
{
  recvDataFunc(userData,fileId);
}

void recvDataFunc(void* userData, void* fileId)
{
  CASTP(Network,userData)->recvMsg(fileId);
  putBackCleanEvent();
}

#if 0


#include <mondrian/command.h>

bool mainRecvFunc(const Cback_struct& cb)
{
	static int msgCounter = 0;
  Object* msg = cb.callData();
  if(validObject(msg))
  {
	String* str = CASTP(String,
		CASTP(OrderedCltn,msg)->first());
	if(str->value() != msgCounter++)
		cerr << "Counter error, Message Received = " << *msg << endl;
  }
  if(msgCounter % 100 == 0)
	cerr << "readed " << msgCounter << endl;
  return NO;
}

bool mainSendFunc(const Cback_struct& cb)
{
	static int msgCounter = 0;
  String message;
  for(int i = 0; i < 100; i++)
  {
    message = form("%4d Message received",msgCounter++);
    CASTP(Network,cb.userData())->sendCltnMsg(message);
  }
  return NO;
}



main(int,char**)
{
  if(getArgc() > 1)
  {
  	Network* network = new Network();
	network->addCback(MessageReceived,mainRecvFunc);
	CppCommand* command = new CppCommand(topLevelWidget,"Child");
	command->addCback(CommandPress,mainSendFunc,network);
	baseMainLoop();
  }
  else
  {
  	Network* network = new Network("Network.exe","Child");
	network->addCback(MessageReceived,mainRecvFunc);
	CppCommand* command = new CppCommand(topLevelWidget,"Parent");
	command->addCback(CommandPress,mainSendFunc,network);
	baseMainLoop();
  }
  return 0;
}

#endif

DEFINE_SIMPLE_CLASS(Network,Object,1,NULL);

Network::Network(const String& name, int port)
  : netName(name)
{
  TRACE_FUNC("Network::Network");
  char* host = "localhost";
  searchOption("-host",host);
  Tcpip tcpip;
  Pier pier = tcpip.connect(host,port);
  outChannel = pier.out;
  inChannel = pier.in;
  char* msg = (char*)netName();
  int wr = write(outChannel,msg,strlen(msg)+1);
  cout << "Name Sended = " << wr << " " << msg << endl;
  XtAddInput(inChannel,XtInputReadMask,xInputFunc,(caddr_t)this);
}


Network::Network(int port)
{
  TRACE_FUNC("Network::Network");
  Tcpip tcpip;
  String nodeRecv;
  Pier pier = tcpip.accept(port,nodeRecv);
  outChannel = pier.out;
  inChannel = pier.in;

  char msg[200]; msg[0] = 0;
  int rd = read(inChannel,msg,200);
  cout << "Name Received = " << rd << " " << msg << endl;
  netName = msg;
  XtAddInput(inChannel,XtInputReadMask,xInputFunc,(caddr_t)this);
}




Network::~Network()
{
  TRACE_FUNC("Network::~Network");
  close(outChannel);
  close(inChannel);
}





void Network::recvMsg(void* fileId)
{
  TRACE_FUNC("Network::recvMsg");

  static char buffer[10000];
  buffer[0] = 0;
  int readed = read(inChannel,buffer,10000);
# if !defined(ultrix) & !defined(LYNXOS)
   istrstream strm(buffer, readed);
# else
   streambuf strmBuf(buffer, readed);
   strmBuf.pptr = strmBuf.base + readed;
   istream strm(&strmBuf);
# endif

  if(readed == 0)
  {
	cerr << "pipe closed" << endl;
	XtRemoveInput(*(XtInputId*)fileId);
	callCbacks(ConnectionClosed);
  }
  // cerr << "Received " << readed << endl; // << " " << buffer << endl;
  while(!strm.eof())
  {
    Object* ob = readFrom(strm);
    if(ob == nil)
	break;
    // cerr << "read as " << *ob << endl;
    if(ob->isMemberOf(class_Symbol) && ob->isEqual(ConnectionClosed))
    {
	callCbacks(ConnectionClosed);
	delete ob;
    }
    else
    	callCbacks(MessageReceived,ob);
  }
}


void Network::sendMsg(Object& ob)
{
  TRACE_FUNC("Network::sendMsg");
  // cout << "start send Message" << endl;
    static char buffer[10001];

  buffer[0] = buffer[10000] = 0;
# if !defined(ultrix) & !defined(LYNXOS)
  ostrstream strm(buffer,10000);
#else
  streambuf strmBuf(buffer,10000);
  ostream strm(&strmBuf);
#endif
  ob.storeOn(strm);
  strm.put((char)0);
  int sended = strlen(buffer);
  // cout << "to send = " << sended << " bytes" << endl;
  write(outChannel,buffer,sended);
  // cout << "end send Message" << endl;
}



void Network::sendCltnMsg(const String& name,Object* p1,Object* p2,Object* p3,Object* p4,Object* p5,Object* p6)
{
  TRACE_FUNC("Network::sendCltnMsg");
  OrderedCltn cltn;
  cltn.add((Object&)name);
  if(p1 != nil)
  {
     cltn.add(*p1);
     if(p2 != nil)
     {
	cltn.add(*p2);
  	if(p3 != nil)
	{
	   cltn.add(*p3);
           if(p4 != nil)
	   {
		cltn.add(*p4);
 	   	if(p5 != nil)
		{
		    cltn.add(*p5);
  		    if(p6 != nil)
			cltn.add(*p6);
		}
	   }
	}
     }
  }
  sendMsg(cltn);
}


void Network::closeConnection()
{
  TRACE_FUNC("Network::closeConnection");
  sendMsg(ConnectionClosed);
}




Object* Network::editorTrace(String& s)
{
  if(s == "netName")
  {
	s = netName.printOnString();
	return (Object*)&netName;
  }
  return nil;
}

/* End of File NETWORK */
