/* File Network.h  definition of class Network */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#ifndef NETWORK_H
#define NETWORK_H

#include <oak/object.h>

#include <oak/oakstrn.h>

class Tcpip;




extern Symbol MessageReceived;
extern Symbol ConnectionClosed;


extern Class class_Network;

class Network : public Object
{
	DEFINE_CLASS_METHOD(Network);
	DEFINE_IDLE_STORE_METHOD(Network,Object);
	friend void recvDataFunc(void* userData, void* fileId);

  protected:
	int inChannel;
	int outChannel;
	String netName;


  protected:
	void recvMsg(void* fileId);
	void sendMsg(Object& ob);

  public:
	Network(const String& name, int port =0);
	Network(int port =0);
	~Network();


	void sendCltnMsg(const String& name, Object* p1 =nil, Object* p2 =nil, Object* p3 =nil, Object* p4 =nil, Object* p5 =nil, Object* p6 =nil);
	void closeConnection();

	Object* editorTrace(String& member);

};

#endif /* NETWORK */
