/* File RailPerifery.C  implement ....*/
#define RAILPERIFERY_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "RailPerifery.h"

#include <mondrian/compicon.h>
#include "Rail.h"


DEFINE_SIMPLE_CLASS(RailPerifery,Object,1,NULL);
#define THIS RailPerifery
#define BASE Object


void RailPerifery::storer(fileDescTy& fd) const
  { BASE::storer(fd); }

void RailPerifery::storer(ostream& strm) const
{
  TRACE_FUNC("RailPerifery::storer");
  BASE::storer(strm);
  icon_name.storeOn(strm);
  icon_pos.storeOn(strm);
  rail_at->storeOn(strm);
}

RailPerifery::RailPerifery(fileDescTy& fd, RailPerifery& where)
  :BASE(fd,where)  { THIS_EQUAL_WHERE(where); } 

RailPerifery::RailPerifery(istream& strm, RailPerifery& where)
  :BASE(strm,where), state("RailPeriferyStatus")
{
  THIS_EQUAL_WHERE(where);
  TRACE_FUNC("RailPerifery::fileConstructor");
  readFrom(strm,"Symbol",icon_name);
  readFrom(strm,"RailPos",icon_pos);
  rail_at = CASTP(Rail,readFrom(strm));
  icon = (CompositeIcon*)nil;
}


RailPerifery::RailPerifery(const String& name)
  : icon_name(name), state("RailPeriferyStatus")
{
  TRACE_FUNC("RailPerifery::RailPerifery");
  rail_at = (Rail*)nil;
  icon = (CompositeIcon*)nil;
}


RailPerifery::RailPerifery()
  : icon_name("RailPerifery"), state("RailPeriferyStatus")
{
  TRACE_FUNC("RailPerifery::RailPerifery");
  rail_at = (Rail*)nil;
  icon = (CompositeIcon*)nil;
}



RailPerifery::~RailPerifery()
{
  TRACE_FUNC("RailPerifery::~RailPerifery");
}






const Symbol& RailPerifery::name() const
{
  TRACE_FUNC("RailPerifery::name");
  return icon_name;
}


void RailPerifery::setName(const String& name)
{
  TRACE_FUNC("RailPerifery::setName");
  icon_name = name;
}


CompositeIcon* RailPerifery::setIcon(Rail*)
{
  TRACE_FUNC("RailPerifery::setIcon");
  derivedClassResponsibility("setIcon");
  return icon;
}


CompositeIcon* RailPerifery::getIcon()
{
  TRACE_FUNC("RailPerifery::getIcon()");
  return icon;
}


Rail* RailPerifery::railAt()
{
  TRACE_FUNC("RailPerifery::railAt");
  return rail_at;
}


void RailPerifery::setStatus(const Symbol& status)
{
  TRACE_FUNC("RailPerifery::setStatus");
  state = status;
}


const Symbol& RailPerifery::getStatus() const
{
  TRACE_FUNC("RailPerifery::getStatus");
  return state;
}




Object* RailPerifery::editorTrace(String& s)
{
  if(s == "icon")
  {
	s = icon->printOnString();
	return (Object*)icon;
  }
  else
  if(s == "icon_name")
  {
	s = icon_name.printOnString();
	return (Object*)&icon_name;
  }
  else
  if(s == "icon_pos")
  {
	s = icon_pos.printOnString();
	return (Object*)&icon_pos;
  }
  else
  if(s == "rail_at")
  {
	s = rail_at->printOnString();
	return (Object*)rail_at;
  }
  else
  if(s == "state")
  {
	s = state.printOnString();
	return (Object*)&state;
  }
  return nil;
}

/* End of File RailPerifery.C */

