/* File SimpleStore.h  definition of ....*/
#ifndef SIMPLESTORE_H
#define SIMPLESTORE_H


#include <rodin/server.h>

#include <oak/vseqcltn.h>

class Piece;


extern Symbol RemoveSignal;
extern Symbol FullSignal;

extern Class class_SimpleStore;

class SimpleStore : public Server
{
	DEFINE_CLASS_METHOD(SimpleStore);
	DEFINE_IDLE_STORE_METHOD(SimpleStore,Server);

  protected:
	VSeqCltn buffer;


	void printOn(ostream& strm) const;

  public:
	SimpleStore(const char* name ="Store", int size =1);
	~SimpleStore();


	void addPiece(Piece* piece);
	Piece* removePiece();
	Piece* firstPiece();
	void deleteAllPiece();
	void resizePiece(size_t sz);
	size_t numberOfPiece() const;

	Object* editorTrace(String& member);

};

#endif /* SIMPLESTORE_H */

