/* File StubTemplate.C  implement ....*/
#define STUBTEMPLATE_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "StubTemplate.h"


#include <oak/orderedc.h>

Symbol StubWaitEvent("StubWaitEvent");


Symbol StubDoSome("StubDoSome");
DEFINE_SIMPLE_CLASS(StubTemplate,Server,1,NULL);
#define THIS StubTemplate
#define BASE Server


StubTemplate::StubTemplate(const char* name)
  :BASE(name), network(name)
{
}



StubTemplate::~StubTemplate()
{
  network.closeConnection();
  // assert(!ev.someAttach()); // forgot some detach
  // assert(size() == 0); // no more service run
}




Object* StubTemplate::doService(Service* service)
{

  CBACK_TRACE(service,"StubTemplate_doService|_START_");
  GET_ARG(0,Symbol,serviceKind);
  /* GET_ARG(1,SomeType,servArg1); */

  CBACK_TRACE(service,"StubTemplate_doService|538126468");
  String execString = "exec" + String(serviceKind);
  Integer serviceId( int(service) );
  // prepare other parameter for send message

  CBACK_TRACE(service,"StubTemplate_doService|537990276");
  
  ev.attachTo(&network,MessageReceived,service);
  network.sendCltnMsg(execString,&serviceId);

  CBACK_TRACE(service,"StubTemplate_doService|538140292");
  while (YES)
  {
      service->setStatus(StubWaitEvent);

      CBACK_TRACE(service,"StubTemplate_doService|538181380");
      
      ev.waitEvent(MessageReceived);
      Object* data = ev.callData();

      CBACK_TRACE(service,"StubTemplate_doService|538198020");
      if( validObject(data) && data->isKindOf(class_OrderedCltn) )
      {
      }
      else
      {
          continue;
      }
      OrderedCltn& message = *CASTP(OrderedCltn,data);

      CBACK_TRACE(service,"StubTemplate_doService|538245124");
      if( serviceId == *message[2] )
      {
      }
      else
      {
          continue;
      }
      Symbol sym = *CASTP(Symbol,message[1]);
      message.deleteAll();
      delete data;

      CBACK_TRACE(service,"StubTemplate_doService|538286468");
      if( sym == ServiceTerminated )
      {
          break;
      }
      else
      {
          if( sym == ServiceRunning )
          {
          }
          else
          {
              
              service->setStatus(sym);

              CBACK_TRACE(service,"StubTemplate_doService|538316164");
          }
      }
  }
  
  ev.detachFrom(&network,MessageReceived,service);

  CBACK_TRACE(service,"StubTemplate_doService|538321668");

  CBACK_TRACE(service,"StubTemplate_doService|538110724");
  return nil;
}




void StubTemplate::execSome()
{
  execService(&StubDoSome);
}




Object* StubTemplate::editorTrace(String& s)
{
  if(s == "network")
  {
	s = network.printOnString();
	return (Object*)&network;
  }
  else
  if(s == "ev")
  {
	s = ev.printOnString();
	return (Object*)&ev;
  }
  return nil;
}

/* End of File StubTemplate.C */

