/* File Topology.C  implementation of class Topology */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#define TOPOLOGY_C

#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>
#include <mondrian/widget.h>

#include "Topology.h"

#include "RailPos.h"
#include "Rail.h"
#include "TurnRail.h"
#include <mondrian/graphic.h>
#include "RailSemaph.h"
#include "ChangeRail.h"




#include <oak/oakstrm.h>
#include <oak/arrayob.h>
#include <oak/assocint.h>
#include <oak/assoc.h>
#include <oak/stack.h>

#include <mondrian/command.h>
#include <oak/floatrec.h>

#include <rodin/schedule.h>

#include <oak/random.h>
RandomLinear* changeRand = NULL;

#if 0
main(int,char**)
{
  Topology* top = new Topology;

  top->commandWidget()->label("Q");
  top->commandWidget()->addQuit();

  top->waitMove();

  top->commandWidget()->label("E");
  top->commandWidget()->addBreak();

  cppMainLoop();
  delete top;
  exitMainLoop();
  return 0;
}
#endif

DEFINE_SIMPLE_CLASS(Topology,Object,1,NULL);
#define THIS Topology
#define BASE Object


Topology::Topology()
  :/*BASE("Topology"),*/ changeIndex(0),
   carts(10)
{
  graph = new CppGraphic(topLevel,"Topology");
  init();
}


Topology::Topology(Object* parentWidget)
  :/*BASE("Topology"),*/ changeIndex(0),
   carts(10)
{
  graph = new CppGraphic(CASTP(CppWidget,parentWidget)
				,"Topology");
  init();
}







void Topology::init()
{
  TRACE_FUNC("Topology::init");
  graph->worldRect(0,0,100,100);
  // graph->absRect(FloatRect(0,0,700,500));
  graph->resize(400,300);

  char* opt = "layout.rail";
  searchOption("-file",opt);
  String fileName(opt);
  if( fileName.inString(".rail") < 0)
	fileName += ".rail";
  if(!fileExist(fileName))
  	setOAKerror(OAK_GENERIC,DEFAULT,
		"FILE_NOT_FOUND", "file of rails ", opt, "");

  OrderedCltn cltn;
  Istream in(fileName);
  readFrom(in(),"OrderedCltn",cltn);
  in.close();
  OrderedCltn cartCltn;
  DO(cltn,Object,ob)
    if(ob->isKindOf(class_Rail))
	rails.add(*ob);
    else
    if(ob->isKindOf(class_Cart))
	cartCltn.add(*ob);
    else
    if(ob->isKindOf(class_Station))
	stations.add(*ob);
    else
	assert(0);
  OD
  carts.reSize(cartCltn.size());
  carts.addCltn(cartCltn);

  DO(rails,Rail,r)
     	r->x(0); r->y(0);
	r->initAfterLoad();
	graph->add(*r);
	if(r->isKindOf(class_ChangeRail))
		changes.add(*r);
  OD
  DO(stations,Station,station)
	DrawIcon* draw = station->getIcon();
     	// draw->x(0); draw->y(0);
	graph->add(*draw);
	railOfStation.addAssoc(*station->railAt(),*station);
  OD
  DO(carts,Cart,cart)
	DrawIcon* draw = cart->getIcon();
     	// draw->x(0); draw->y(0);
	graph->add(*draw);
  OD

  changeSize = changes.size();

  char* aveStr = "10";
  char* widStr = "20";
  searchOption("-a",aveStr);
  searchOption("-w",widStr);
  long ave = (int)String(aveStr).value();
  long wid = (int)String(widStr).value();
  if(ave < wid / 2 + 1)
	ave = wid / 2 + 1;
  changeRand = new RandomLinear(ave,wid);
  determSemaph();
  initCartSemaph();
}


void Topology::determSemaph()
{
  TRACE_FUNC("Topology::determSemaph");

#if 0
  realizeTopLevel();
  ArrayOb colors(10);
  for(int i = 0 ; i < 10; i++)
	colors[i] = new String(readString(form("AgvColor%d",i),"yellow"));
#endif

  Stack lastChange;
  OrderedCltn semaphIdCltn;

  Dictionary railVisit;
  Dictionary changeVisit;

  int semaphId = -1;

  Rail* rail0 = CASTP(Rail,changes.first());
 
  if(rail0->railSize() < rail0->railCapacity())
  	setOAKerror(OAK_GENERIC,DEFAULT,"CHANGE_NOFULL",
    		"One ChangeRail have some edge free","","");

  Rail* rail1 = rail0->railAt(1);
  Rail* rail2 = rail0;


  while(YES)
  {
    if(rail2->isKindOf(class_ChangeRail))
    {
	LookupKey* ass = changeVisit.lookupAtKey(*rail2);
	if(ass != nil)
	{
	  AssocInt* assInt = CASTP(AssocInt,lastChange.top());
	  int lastOrient = assInt->intValue();
	  if(rail2 != rail0)
	  {
	    ArrayOb& array = *CASTP(ArrayOb,ass->value());
	    int from = rail2->setFrom(rail1);
	    assert(array[from - 1] == nil);
	    array[from - 1] = semaphIdCltn.last();
	    ass = changeVisit.lookupAtKey(*rail0);
	    assert(ass != nil);
	  }
	  ArrayOb& array = *CASTP(ArrayOb,ass->value());
	  // cout << "Array = " << array << endl;
	  // cout << "AssInt = " << *assInt << endl;
  	  while(lastOrient++ < 3)
	  {
		// cout << "lastOrient == " << lastOrient << endl;
		if(array[lastOrient - 1] != nil)
			continue;
		// cout << "Array[lastOrient] == " 
		// 	<< *array[lastOrient-1] << endl;

		assInt->intValue(lastOrient);
	  	rail1 = rail0;
	  	rail2 = rail0->railAt(lastOrient);
	  	semaphId++;
	  	semaphIdCltn.add(*new Integer(semaphId));
	  	assert(array[lastOrient - 1] == nil);
	  	array[lastOrient - 1] = semaphIdCltn.last();
	  	assert(array[lastOrient - 1] != nil);
		break;
	  }
	  if(lastOrient > 3)
	  {
	    // cout << "Array = " << array << endl;
	    Object* poped = lastChange.pop();
	    assert(assInt ==  poped);
	    if(lastChange.isEmpty())
		break;
	    assInt = CASTP(AssocInt,lastChange.top());
	    lastOrient = assInt->intValue();
	    rail0 = CASTP(Rail,assInt->key());
	    rail1 = rail0->railAt(lastOrient);
	    rail2 = rail0;
	  }
	}
	else
	{
	  lastChange.push(*new AssocInt(*rail2,0));
	  ArrayOb& array = *new ArrayOb(3);
	  changeVisit.addAssoc(*rail2,array);
	  if(lastChange.size() > 1)
	  {
	    int from = rail2->setFrom(rail1);
	    assert(array[from - 1] == nil);
	    array[from - 1] = semaphIdCltn.last();
	  }
	  if(rail2->railSize() < rail2->railCapacity())
        {
  		setOAKerror(OAK_GENERIC,DEFAULT,"CHANGE_NOFULL",
    			"One ChangeRail have some edge free","","");
	  }
	  rail0 = rail2;
	}	
    }
    else
    {
	assert(!railVisit.includesKey(*rail2));
	Integer& semaph = *CASTP(Integer,semaphIdCltn.last());
	railVisit.addAssoc(*rail2,semaph);
#if 0
	String& color = *CASTP(String,colors[semaph.value() % 10]);
	rail2->highLight(color);
	graph->redraw();
   	sleepForTime(500);
#endif
	rail2->setFrom(rail1);
	rail1 = rail2;
	rail2 = rail1->nextRail();
	if(railVisit.includesKey(*rail2))
	{
		rail2 = rail0;
		rail1 = rail0;
	}
    }
  }

  Dictionary semaphDict;

  DO(semaphIdCltn,Integer,intPt)
	semaphDict.addAssoc(*intPt,*new RailSemaph);
  OD

  DO(changeVisit,Assoc,ass)
    ChangeRail* r = CASTP(ChangeRail,ass->key());
    ArrayOb& array = *CASTP(ArrayOb,ass->value());
    for(int i = 0; i < 3;)
    {
     	Integer& semaphId = *CASTP(Integer,array[i++]);
   	RailSemaph* semaph = 
		CASTP(RailSemaph,semaphDict.atKey(semaphId));
	semaph->addChange(r,i);
    }
  OD

  railVisit.deleteAll();
  DO(changeVisit,Assoc,ass)
	ArrayOb* array = CASTP(ArrayOb,ass->value());
	delete array;
  OD
  changeVisit.deleteAll();
  semaphDict.deleteAll();
  semaphIdCltn.deleteAll();
}


void Topology::initCartSemaph()
{
  TRACE_FUNC("Topology::initCartSemaph");

  DO(carts,Cart,cart)
    Rail* rail = cart->railAt();

    if(rail->isKindOf(class_ChangeRail))
	setOAKerror(OAK_GENERIC,DEFAULT,"BAD_CART",
		"cannot start a cart in an ChangeRail","","");

    Rail* lastRail = rail;
    while(!rail->isKindOf(class_ChangeRail))
    {
	lastRail = rail;
	rail = rail->nextRail();
	rail->setFrom(lastRail);
    }
    ChangeRail* change = CASTP(ChangeRail,rail);
    RailSemaph* sem = change->fromSemaph();

    if(sem->isBusy())
	setOAKerror(OAK_GENERIC,DEFAULT,"TWO_CART",
		"thow cart on the same zone","","");
    sem->wait();
  OD
}


bool Topology::atHome(Rail* rail, Station*& stat)
{
  TRACE_FUNC("Topology::atHome");
  LookupKey* look = railOfStation.lookupAtKey(*rail);
  if(look == nil)
	return NO;
  if(CASTP(Station,look->value())->name() != "Home")
	return NO;
  stat = (Station*)look->value();
  return YES;
}



Cart* Topology::waitGetAgv(const String& whereToGo)
{
  TRACE_FUNC("Topology::waitGetAgv");
  Cart* agv = CASTP(Cart,carts.removeFirst());
  
  Station* station = NULL;
  DO(stations,Station,st)
	if(st->name() != whereToGo)
		continue;
      station = st;
	break;
  OD
  assert(station != NULL);
#if 1
  Rail* rail = agv->railAt();
#else
  ArrayOb& array = *new ArrayOb;
  agvDict.addAssoc(*agv,array);
  ChangeRail* change = CASTP(ChangeRail,changes.atIndex(
			changeRand->next() % changeSize));
  
  Rail* fromRail = change->nextRail();
  RailSemaph* sem1 = change->toSemaph();
  sem1->wait();
  // change->setFrom(fromRail);

  RailSemaph* sem2 = change->toSemaph(fromRail);
  if(sem2->isBusy() && !changesBusy.includes(*change))
  {
     change->toggleChange();
     sem2 = change->toSemaph(fromRail);
     sem2->wait();
  }
  else
	sem2->wait();
  change->setFrom(fromRail);
  agv->setIcon(change);
  changesBusy.add(*change);

  graph->add(*agv->getIcon());
  graph->draw(change);
  Rail* rail = sem1->otherChange(change);
  if(rail != nil)
	graph->draw(rail);
  rail = sem2->otherChange(change);
  if(rail != nil)
	graph->draw(rail);
  array[0] = change;
#endif
	  
  return agv;
}


void Topology::waitMoveAgv(Cart* agv, const String& whereToGo)
{
  TRACE_FUNC("Topology::waitMoveAgv");
  Rail* rail = agv->railAt();

  DO(stations,Station,st)
	if(st->railAt() != rail)
		continue;
	st->setStatus(StationFree);
	break;
  OD

  Station* station = NULL;
  Rail* railWhereToGo = NULL;
  if(whereToGo != "Home")
  {
    DO(stations,Station,st)
	if(st->name() != whereToGo)
		continue;
      station = st;
	break;
    OD
    assert(station != NULL);
    railWhereToGo = station->railAt();
  }

  while(station != NULL && rail != railWhereToGo
			||
	  station == NULL && !atHome(rail,station))
  {
  	Rail* nextRail = rail->nextRail();
	if(nextRail->isKindOf(class_ChangeRail))
	{
	  ChangeRail* change = (ChangeRail*)nextRail;
	  RailSemaph* sem = change->toSemaph(rail);
	  if(sem->isBusy() && !changesBusy.includes(*change))
	  {
	     change->toggleChange();
	     sem = change->toSemaph(rail);
	     sem->wait();
	  }
	  else
	  {
		sem->wait();
	  }
  	  changesBusy.add(*change);

	  change = sem->otherChange(change);
	  if(change != nil)
		  graph->draw(change);

	  change = CASTP(ChangeRail,changes.atIndex(
			changeIndex++ % changeSize)); 
	  if(!changesBusy.includes(*change))
		change->toggleChange();
	}

      if(rail->isKindOf(class_ChangeRail))
      {
	    changesBusy.remove(*rail);

	    ChangeRail* change = (ChangeRail*)rail;
	    RailSemaph* sem = change->fromSemaph();
	    sem->signal();
	    change = sem->otherChange(change);
	    if(change != nil)
		graph->draw(change);
      }

	graph->erase(agv->getIcon());
	graph->remove(*agv->getIcon());
	graph->draw(rail);
	nextRail->setFrom(rail);
	rail = nextRail;
	agv->setIcon(rail);
	graph->draw(rail);
	graph->add(*agv->getIcon());
	graph->draw(agv->getIcon());

	// sleepForTime(50);
  	waitFor(1);	
  }
  station->setStatus(StationBusy);
}



void Topology::waitPutAgv(Cart* agv)
{
  TRACE_FUNC("Topology::waitPutAgv");
  assert(!carts.isFull());
  carts.add(*agv);
}


bool Topology::cartRequire()
{
  TRACE_FUNC("Topology::cartRequire");
  return carts.processQueued() > 0;
}


CppGraphic* Topology::widget()
{
  TRACE_FUNC("Topology::widget");
  return graph;
}


void Topology::start()
{
  TRACE_FUNC("Topology::start");
  realizeTopLevel();
  graph->commandWidget()->label("G");
  graph->commandWidget()->addBreak();
  cppMainLoop();
  graph->commandWidget()->label("Q");
  graph->commandWidget()->removeBreak();
  graph->commandWidget()->addQuit();

}


void Topology::stop()
{
  TRACE_FUNC("Topology::stop");
  graph->commandWidget()->removeQuit();
  graph->commandWidget()->label("E");
  graph->commandWidget()->addBreak();
  cppMainLoop();
  exitMainLoop();
}




Object* Topology::editorTrace(String& s)
{
  if(s == "graph")
  {
	s = graph->printOnString();
	return (Object*)graph;
  }
  else
  if(s == "railOfStation")
  {
	s = railOfStation.printOnString();
	return (Object*)&railOfStation;
  }
  else
  if(s == "rails")
  {
	s = rails.printOnString();
	return (Object*)&rails;
  }
  else
  if(s == "changes")
  {
	s = changes.printOnString();
	return (Object*)&changes;
  }
  else
  if(s == "carts")
  {
	s = carts.printOnString();
	return (Object*)&carts;
  }
  else
  if(s == "stations")
  {
	s = stations.printOnString();
	return (Object*)&stations;
  }
  else
  if(s == "agvDict")
  {
	s = agvDict.printOnString();
	return (Object*)&agvDict;
  }
  else
  if(s == "changesBusy")
  {
	s = changesBusy.printOnString();
	return (Object*)&changesBusy;
  }
  return nil;
}

/* End of File TOPOLOGY */
