/* File Topology.h  definition of class Topology */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#ifndef TOPOLOGY_H
#define TOPOLOGY_H

#include <oak/object.h>

#include "Rail.h"
#include <oak/set.h>
#include <rodin/condcltn.h>
#include <oak/arrayob.h>
#include <oak/orderedc.h>
#include <oak/identdic.h>
#include "Cart.h"
#include "Station.h"
#include <oak/dictiona.h>
#include "ChangeRail.h"

class RailPos;
class Rail;
class TurnRail;
class CppGraphic;
class RailSemaph;
class ChangeRail;






extern Class class_Topology;

class Topology : public Object
{
	DEFINE_CLASS_METHOD(Topology);
	DEFINE_IDLE_STORE_METHOD(Topology,Object);

  protected:
	int changeIndex;
	int changeSize;
	CppGraphic* graph;
	Dictionary railOfStation;

	OrderedCltn rails;
	OrderedCltn changes;
	CondCltn carts;
	OrderedCltn stations;
	IdentDict agvDict;
	Set changesBusy;

  protected:
	void init();
	void determSemaph();
	void initCartSemaph();
	bool atHome(Rail* rail, Station*& stat);

  public:
	Topology();
	Topology(Object* parentWidget);


	Cart* waitGetAgv(const String& whereToGo);
	void waitMoveAgv(Cart* agv, const String& whereToGo);
	void waitPutAgv(Cart* agv);
	bool cartRequire();
	CppGraphic* widget();
	void start();
	void stop();

	Object* editorTrace(String& member);

};

#endif /* TOPOLOGY */
