/* File Transport.C  implement ....*/
#define TRANSPORT_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>
#include <mondrian/widget.h>

#include "Transport.h"

#include "Cart.h"


Symbol TranspWaitCart = "TranspWaitCart";
Symbol TranspGoSrc = "TranspGoSrc";
Symbol TranspGoDst = "TranspGoDst";
Symbol TranspGoHome = "TranspGoHome";
Symbol TranspStop = "TranspStop";
Symbol WaitLoad = "WaitLoad";
Symbol WaitUnload = "WaitUnload";

Symbol TrDoMission = "TrDoMission";
Symbol TrAddPiece = "TrAddPiece";
Symbol TrRemovePiece = "TrRemovePiece";

String homeName = "Home";
#if 0
#include <mondrian/form.h>
#include <mondrian/toplevel.h>

#include <classEdt/animobj.h>
#include <classEdt/ctrlpanel.h>

#include <rodin/service.h>
#include <rodin/evnthdlr.h>
#include <mondrian/form.h>
#include <mondrian/toplevel.h>

#include <classEdt/animobj.h>
#include <classEdt/ctrlpanel.h>

#include <rodin/service.h>
#include <rodin/evnthdlr.h>

main(int,char**)
{
  Transport* tr = new Transport("Transport",3);

  CppForm* baseForm = new CppForm(topLevel,"BaseForm");
  ControlPanel* ctrlPanel = new ControlPanel(baseForm);
  AnimateObject& anim = *new AnimateObject(baseForm,tr,"Transport");
  baseForm->topBottom(ctrlPanel,anim);
  realizeTopLevel();
  ctrlPanel->attachAnimator(anim);
  ctrlPanel->waitStep();

  Piece* piece = new Piece("Biella");
  EventHandler* ev = new EventHandler;

  Service* servTr = tr->joinMission(tr,piece,tr);
  ev->attachTo(servTr,TranspWaitLoad);
  ev->waitEvent();
  ev->detachFrom(servTr,TranspWaitLoad);
  tr->waitAddPiece(piece);
  ev->attachTo(servTr,TranspWaitUnload);
  ev->waitEvent();
  ev->detachFrom(servTr,TranspWaitUnload);
  piece = tr->waitRemovePiece(servTr);
  tr->signal(servTr);
  ctrlPanel->waitEnd();
  delete tr;
  delete piece;
  delete ev;

  return 0;
}


#endif

DEFINE_SIMPLE_CLASS(Transport,Server,1,NULL);
#define THIS Transport
#define BASE Server


Transport::Transport(const char* name, int cartSz)
  : BASE(name), pieces(cartSz)
{
}


Transport::Transport(Object* parentWidget, const char* name, int cartSz)
  : BASE(name), pieces(cartSz), topology(parentWidget)
{
  TRACE_FUNC("Transport::Transport");
}




Time_t Transport::srcTime(Cart& cart, Server& src)
{
  cout << "Cart " << cart << " Go to " << src.name() << endl;
  return 3;
}


Time_t Transport::dstTime(Server& src, Cart& cart, Server& dst)
{
  cout << "Cart " << cart << " Go from " << src.name()
		<< " to " << dst.name() << endl;
  return 3;
}


Time_t Transport::homeTime(Server& dst, Cart& cart)
{
  cout << "Cart " << cart << " Go from " << dst.name()
		<< " to  Home" << endl;
  return 3;
}



Object* Transport::doMission(Service* service)
{
  TRACE_FUNC("Transport::doMission");
  CBACK_TRACE(service,"Transport_doMission|_START_");
  GET_ARG(1,Server,src);
  GET_ARG(2,Piece,piece);
  GET_ARG(3,Server,dst);
  CBACK_TRACE(service,"Transport_doMission|2716460");
  service->setStatus(TranspWaitCart, service);
  CBACK_TRACE(service,"Transport_doMission|2749228");
  
  Cart* cart = topology.waitGetAgv(src.name());
  CBACK_TRACE(service,"Transport_doMission|2799084");
  service->setStatus(TranspGoSrc, service);
  CBACK_TRACE(service,"Transport_doMission|2818060");
  
  topology.waitMoveAgv(cart,src.name());
  CBACK_TRACE(service,"Transport_doMission|2170708");
  service->setStatus(WaitLoad, &src);
  CBACK_TRACE(service,"Transport_doMission|2915636");
  
  pieces.waitFor(piece);
  cart->setStatus(CartFull);
  CBACK_TRACE(service,"Transport_doMission|2992420");
  service->setStatus(TranspGoDst, &piece);
  CBACK_TRACE(service,"Transport_doMission|3101596");
  
  topology.waitMoveAgv(cart,dst.name());
  CBACK_TRACE(service,"Transport_doMission|2308732");
  service->setStatus(WaitUnload, &dst);
  CBACK_TRACE(service,"Transport_doMission|3180132");
  
  pieces.waitForNot(piece);
  cart->setStatus(CartEmpty);
  CBACK_TRACE(service,"Transport_doMission|3233084");
  if( topology.cartRequire() )
  {
      CBACK_TRACE(service,"Transport_doMission|1701436");
  }
  else
  {
      CBACK_TRACE(service,"Transport_doMission|1701436");
      service->setStatus(TranspGoHome, service);
      CBACK_TRACE(service,"Transport_doMission|3262724");
      
      cart->setStatus(CartGoHome);
      topology.waitMoveAgv(cart,homeName);
      cart->setStatus(CartEmpty);
      CBACK_TRACE(service,"Transport_doMission|1872532");
  }
  service->setStatus(TranspStop);
  CBACK_TRACE(service,"Transport_doMission|3335708");
  
  cart->setStatus(CartEmpty);
  topology.waitPutAgv(cart);
  CBACK_TRACE(service,"Transport_doMission|2047844");

  CBACK_TRACE(service,"Transport_doMission|2706852");
  return nil;
}


Object* Transport::doAddPiece(Service* service)
{
  TRACE_FUNC("Transport::doAddPiece");
  CBACK_TRACE(service,"Transport_doAddPiece|_START_");
  
  GET_ARG(1,Piece,piece);
  checkAddPiece(piece);
  assert(!pieces.isFull());
  pieces.add(piece);
  CBACK_TRACE(service,"Transport_doAddPiece|4483220");

  CBACK_TRACE(service,"Transport_doAddPiece|4612500");
  return nil;
}


Object* Transport::doRemovePiece(Service* service)
{
  TRACE_FUNC("Transport::doRemovePiece");
  CBACK_TRACE(service,"Transport_doRemovePiece|_START_");
  
  GET_ARG(1,Service,misServ);
  assert(*misServ.getStatus() == WaitUnload);
  Piece* piece = CASTP(Piece,misServ.getArg(2));
  assert(pieces.includes(*piece));
  pieces.remove(*piece);
  CBACK_TRACE(service,"Transport_doRemovePiece|4759980");

  CBACK_TRACE(service,"Transport_doRemovePiece|4752684");
  return piece;
}



Object* Transport::doService(Service* service)
{
  TRACE_FUNC("Transport::doService");
  GET_ARG(0,Symbol,servKind);
  if(&servKind == &TrDoMission)
	return doMission(service);
  else
  if(&servKind == &TrAddPiece)
	return doAddPiece(service);
  else
  if(&servKind == &TrRemovePiece)
	return doRemovePiece(service);
  assert(0);
  return nil;
}


void Transport::checkAddPiece(Piece& piece)
{
  TRACE_FUNC("Transport::checkAddPiece");
  assert(!pieces.includes(piece));
  Service* misServ = NULL;
  DO(*this,Service,s)
	if(s->getArg(2) != &piece ||
		 *s->getStatus() != WaitLoad)
		continue;
	misServ = s;
	break;
  OD
  assert(misServ != NULL);
}



Service* Transport::joinMission(Object* src, Piece* piece, Object* dst)
{
  return joinService(&TrDoMission,src,piece,dst);
}


void Transport::waitAddPiece(Piece* piece)
{
  waitService(&TrAddPiece,piece);
}


Piece* Transport::waitRemovePiece(Service* service)
{
  return CASTP(Piece, waitService(&TrRemovePiece,service));
}


void Transport::start()
{
  TRACE_FUNC("Transport::start");
  topology.start();
}


void Transport::stop()
{
  TRACE_FUNC("Transport::stop");
  while(size() > 0)
	waitFor(10);
  topology.stop();
}




Object* Transport::editorTrace(String& s)
{
  if(s == "topology")
  {
	s = topology.printOnString();
	return (Object*)&topology;
  }
  else
  if(s == "pieces")
  {
	s = pieces.printOnString();
	return (Object*)&pieces;
  }
  return nil;
}

/* End of File Transport.C */

