/* File Transport.h  definition of ....*/
#ifndef TRANSPORT_H
#define TRANSPORT_H


#include <rodin/server.h>

#include <rodin/condcltn.h>
#include "Piece.h"
#include "Topology.h"

class Cart;


extern Symbol TranspWaitCart;
extern Symbol TranspGoSrc;
extern Symbol TranspGoDst;
extern Symbol TranspGoHome;
extern Symbol TranspStop;
extern Symbol WaitLoad;
extern Symbol WaitUnload;

extern Class class_Transport;

class Transport : public Server
{
	DEFINE_CLASS_METHOD(Transport);
	DEFINE_IDLE_STORE_METHOD(Transport,Server);

  protected:
	Topology topology;

	CondCltn pieces;

  private:
	Time_t srcTime(Cart& cart, Server& src);
	Time_t dstTime(Server& src, Cart& cart, Server& dst);
	Time_t homeTime(Server& dst, Cart& cart);
	virtual Object* doMission(Service* service);
	virtual Object* doAddPiece(Service* service);
	virtual Object* doRemovePiece(Service* service);

	Object* doService(Service* service);
	void checkAddPiece(Piece& piece);

  public:
	Transport(const char* name ="Transport", int cartSz =1);
	Transport(Object* parentWidget, const char* name ="Transport", int cartSz =1);


	Service* joinMission(Object* src, Piece* piece, Object* dst);
	void waitAddPiece(Piece* piece);
	Piece* waitRemovePiece(Service* service);
	void start();
	void stop();

	Object* editorTrace(String& member);

};

#endif /* TRANSPORT_H */

