/* File AgvSem.h  definition of class AgvSem */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#ifndef AGVSEM_H
#define AGVSEM_H

#include <editor/semantic.h>

#include "RailIcon.h"
#include <oak/orderedc.h>
#include <oak/point.h>
#include <oak/dictiona.h>
#include "CartIcon.h"
#include <oak/assocint.h>
#include "StationIcon.h"

class TurnIcon;
class RailIcon;
class RailPos;
class ChangeIcon;
class ChangeRail;
class AgvTitle;
class Station;
class Cart;




#define SaveAgvFile "CreateRailFile"
#define RunAgv "RunAgv"
#define AgvVersion  "AgvEditorVersion"

extern Class class_AgvSem;

class AgvSem : public Semantic
{
	DEFINE_CLASS_METHOD(AgvSem);

  protected:
	AgvTitle* title;
	Dictionary railToIcon;

	OrderedCltn rails;
	OrderedCltn carts;
	OrderedCltn stations;
	OrderedCltn freePoints;
	Dictionary pointToRail;

  protected:
	void storer(fileDescTy& fd) const;
	void storer(ostream& strm) const;
	AgvSem(fileDescTy& fd, AgvSem& where);
	AgvSem(istream& strm, AgvSem& where);

	virtual const char* fileExtension() const;
	virtual OrderedCltn& initGraph(OrderedCltn& cltn);
	virtual OrderedCltn& getIcons(OrderedCltn& cltn);
	virtual void setDrawSize();
	virtual OrderedCltn& getCommands(OrderedCltn& cltn);
	virtual IconNode* iconCreate(const String& label, int, int);
	virtual const char* command(const String& label);
	virtual const char* action(IconNode*);
	const char* saveAgvFile();
	virtual void setPosition(IconNode* icon);
	virtual char* checkCollision(IconNode* icon, OrderedCltn& cltn);
	virtual char* checkConnect(IconNode* from, IconNode* to, const Class* linkClass, const FloatPoint& start, const FloatPoint& stop);
	virtual void removeIcon(IconNode* icon);
	virtual void insertIcon(IconNode* icon);
	virtual void removeAll();
	virtual bool checkMotion(IconNode* icon, Point& newPnt);
	void attach(RailIcon* icon);
	void detach(RailIcon* icon);
	RailIcon* iconAtRail(Rail* rail);
	const char* runAgv();

  public:
	AgvSem();
	~AgvSem();



	Object* editorTrace(String& member);

};

#endif /* AGVSEM */

