/* File CartIcon.C  implement ....*/
#define CARTICON_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>
#include <mondrian/widget.h>

#include "CartIcon.h"

#include "RailIcon.h"
#include "Rail.h"
#include "Cart.h"




#include <oak/orderedc.h>
#include <mondrian/compicon.h>



DEFINE_SIMPLE_CLASS(CartIcon,PeriferyIcon,1,NULL);
#define THIS CartIcon
#define BASE PeriferyIcon


void CartIcon::storer(fileDescTy& fd) const
  { BASE::storer(fd); }

void CartIcon::storer(ostream& strm) const
{
  TRACE_FUNC("CartIcon::storer");
  BASE::storer(strm);
}

CartIcon::CartIcon(fileDescTy& fd, CartIcon& where)
  :BASE(fd,where)  { THIS_EQUAL_WHERE(where); } 

CartIcon::CartIcon(istream& strm, CartIcon& where)
  :BASE(strm,where)
{
  THIS_EQUAL_WHERE(where);
  TRACE_FUNC("CartIcon::fileConstructor");
}


CartIcon::CartIcon()
{
  TRACE_FUNC("CartIcon::CartIcon");
}




CartIcon::~CartIcon()
{
  TRACE_FUNC("CartIcon::~CartIcon");
  delete the_perifery;
}





void CartIcon::createGeoIcon()
{
  TRACE_FUNC("CartIcon::createGeoIcon");
  for(int i = 0; i < PERIF_I_W; i++)
        for(int j = 1; j < PERIF_I_H+1; j++)
                geo_icon->add( *new Point(i,j) );
}


void CartIcon::createSemanticIcon()
{
  TRACE_FUNC("CartIcon::createSemanticIcon");
  select_icon = new DrawRect(0.1,1.3,0.8,0.4);
  compIcon->add(*select_icon);
  BASE::createSemanticIcon();
}


void CartIcon::destroySemanticIcon()
{
  TRACE_FUNC("CartIcon::destroySemanticIcon");
}


void CartIcon::buildParam(OrderedCltn& labels, OrderedCltn& values)
{
  TRACE_FUNC("CartIcon::buildParam");
  labels.add(*new String("Cart Name >"));
  BASE::buildParam(labels,values);
}


void CartIcon::consumeParam(OrderedCltn& labels, OrderedCltn& values)
{
  TRACE_FUNC("CartIcon::consumeParam");
  BASE::consumeParam(labels,values);
  if(the_perifery == nil)
	the_perifery = new Cart(icon_name);
  else
	CASTP(Cart,the_perifery)->setName(icon_name);
}


void CartIcon::printOn(ostream& strm) const
{
  TRACE_FUNC("CartIcon::printOn");
  BASE::printOn(strm);
}



Cart* CartIcon::cart()
{
  TRACE_FUNC("CartIcon::cart");
  return CASTP(Cart,the_perifery);
}




Object* CartIcon::editorTrace(String& )
{
  return nil;
}

/* End of File CARTICON */

