/* File ChangeIcon.C  implement ....*/
#define CHANGEICON_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "ChangeIcon.h"

#include "ChangeRail.h"



String globalLenChange("1");
String globalTurnChange("N");
String globalAngChange("30");
String globalRayChange("2");

DEFINE_SIMPLE_CLASS(ChangeIcon,TurnIcon,1,NULL);
#define THIS ChangeIcon
#define BASE TurnIcon


void ChangeIcon::storer(fileDescTy& fd) const
  { BASE::storer(fd); }

void ChangeIcon::storer(ostream& strm) const
{
  TRACE_FUNC("ChangeIcon::storer");
  BASE::storer(strm);
  change_len.storeOn(strm);
  turn_change.storeOn(strm);
}

ChangeIcon::ChangeIcon(fileDescTy& fd, ChangeIcon& where)
  :BASE(fd,where)  { THIS_EQUAL_WHERE(where); } 

ChangeIcon::ChangeIcon(istream& strm, ChangeIcon& where)
  :BASE(strm,where)
{
  THIS_EQUAL_WHERE(where);
  readFrom(strm,"String",change_len);
  readFrom(strm,"String",turn_change);
}


ChangeIcon::ChangeIcon()
  : change_len(globalLenChange),
    turn_change(globalTurnChange)
{
  rail_ang = globalAngChange;
  rail_len = globalRayChange;
}



ChangeIcon::~ChangeIcon()
{
  TRACE_FUNC("ChangeIcon::~ChangeIcon");
}





void ChangeIcon::buildParam(OrderedCltn& labels, OrderedCltn& values)
{
  if(isA() == &class_ChangeIcon)
  	labels.add(*new String("ChangeRail Parameter"));
  labels.add(*new String("Attach In (1, 2 or 3) >"));
  labels.add(*new String("Ray >"));
  labels.add(*new String("Angle >"));
  labels.add(*new String("Length >"));
  labels.add(*new String("Change to Turn (Y or N) >"));
  values.add(where_con);
  values.add(rail_len);
  values.add(rail_ang);
  values.add(change_len);
  values.add(turn_change);
}


void ChangeIcon::consumeParam(OrderedCltn& labels, OrderedCltn& values)
{
  change_len = change_len.trim();
  if(change_len.value() == 0)
	change_len = "1";

  turn_change = turn_change.trim();
  turn_change = turn_change.toUpper();

  BASE::consumeParam(labels,values);

  if(the_rail == nil && isA() == &class_ChangeIcon)
	the_rail = new ChangeRail( rail_ang.value(),
			scaleFact * rail_len.value(),
			scaleFact * change_len.value());
  if(turn_change == "Y")
  	CASTP(ChangeRail,the_rail)->setChange(YES);
  else
  {
	turn_change = "N";
  	CASTP(ChangeRail,the_rail)->setChange(NO);
  }
  globalLenChange = change_len;
  globalTurnChange = turn_change;
  globalAngChange = rail_ang;
  globalRayChange = rail_len;
}





Object* ChangeIcon::editorTrace(String& s)
{
  if(s == "change_len")
  {
	s = change_len.printOnString();
	return (Object*)&change_len;
  }
  else
  if(s == "turn_change")
  {
	s = turn_change.printOnString();
	return (Object*)&turn_change;
  }
  return nil;
}

/* End of File ChangeIcon.C */

