/* File Lot.C  implement ....*/
#define LOT_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "Lot.h"



DEFINE_SIMPLE_CLASS(Lot,Object,1,NULL);
#define THIS Lot
#define BASE Object


void Lot::storer(fileDescTy& fd) const
  { BASE::storer(fd); }

void Lot::storer(ostream& strm) const
{
  TRACE_FUNC("Lot::storer");
  BASE::storer(strm);
  lot_name.storeOn(strm);
  piece_type.storeOn(strm);
  piece_count.storeOn(strm);
}

Lot::Lot(fileDescTy& fd, Lot& where)
  :BASE(fd,where)  { THIS_EQUAL_WHERE(where); } 

Lot::Lot(istream& strm, Lot& where)
  :BASE(strm,where)
{
  THIS_EQUAL_WHERE(where);
  TRACE_FUNC("Lot::fileConstructor");
  readFrom(strm,"Symbol",lot_name);
  readFrom(strm,"Symbol",piece_type);
  readFrom(strm,"Integer",piece_count);
}


Lot::Lot(const Symbol& name, const Symbol& type, int number)
  : lot_name(name), 
    piece_type(type), 
    piece_count(number)
{
  TRACE_FUNC("Lot::Lot");
}


Lot::Lot()
  : lot_name("Lot"), 
    piece_type("Piece"),
    piece_count(1)
{
  TRACE_FUNC("Lot::Lot");
}



Lot::~Lot()
{
  TRACE_FUNC("Lot::~Lot");
}






Symbol Lot::name()
{
  TRACE_FUNC("Lot::name");
  return lot_name;
}


Symbol Lot::pieceType()
{
  TRACE_FUNC("Lot::pieceType");
  return piece_type;
}


int Lot::pieceNumber()
{
  TRACE_FUNC("Lot::pieceNumber");
  return piece_count;
}




Object* Lot::editorTrace(String& s)
{
  if(s == "lot_name")
  {
	s = lot_name.printOnString();
	return (Object*)&lot_name;
  }
  else
  if(s == "piece_type")
  {
	s = piece_type.printOnString();
	return (Object*)&piece_type;
  }
  else
  if(s == "piece_count")
  {
	s = piece_count.printOnString();
	return (Object*)&piece_count;
  }
  return nil;
}

/* End of File Lot.C */

