/* File Machine.C  implement ....*/
#define MACHINE_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "Machine.h"


#include <oak/oakstrn.h>
#include <oak/symbol.h>

Symbol MacWaitWorkEmpty = "MacWaitWorkEmpty";
Symbol MacInNotFull = "MacInNotFull";
Symbol MacStartWork = "MacStartWork";
Symbol MacEndWork = "MacEndWork";
Symbol MacOutFull = "MacOutFull";

Symbol MacDoWork = "MacDoWork";
Symbol MacRemovePiece = "MacRemovePiece";

#if 0
#include <mondrian/form.h>
#include <mondrian/toplevel.h>

#include <classEdt/animobj.h>
#include <classEdt/ctrlpanel.h>

#include <rodin/service.h>
#include <rodin/evnthdlr.h>

main(int,char**)
{
  Machine* mac = new Machine;

  CppForm* baseForm = new CppForm(topLevel,"BaseForm");
  ControlPanel* ctrlPanel = new ControlPanel(baseForm);
  AnimateObject& anim = *new AnimateObject(baseForm,mac,"Machine");
  baseForm->topBottom(ctrlPanel,anim);
  realizeTopLevel();
  ctrlPanel->attachAnimator(anim);
  ctrlPanel->waitStep();

  Piece* piece = new Piece("Biella");
  Symbol* partProgram = new Symbol("Fora1Biella");
  EventHandler* ev = new EventHandler;

  Service* servMac = mac->joinWork(piece,partProgram);
  ev->attachTo(servMac,MacOutFull);
  ev->waitEvent();
  ev->detachFrom(servMac,MacOutFull);
  mac->signal(servMac);
  piece = mac->waitRemovePiece();
  ctrlPanel->waitEnd();
  delete mac;
  delete piece;
  delete partProgram;
  delete ev;

  return 0;
}


#endif
Symbol OutFull = "OutFull";
Symbol InNotFull = "InNotFull";
Symbol StartWork = "StartWork";
Symbol EndWork = "EndWork";

DEFINE_SIMPLE_CLASS(Machine,Server,1,NULL);
#define THIS Machine
#define BASE Server


Machine::Machine(const char* name, int inputSz)
  :BASE(name), input(inputSz), work(1), output(1)
{
}




Time_t Machine::workTime(const Symbol& partProgram)
{
  if(partProgram == "Fora1Biella")
        return 6;
  else
  if(partProgram == "Fora2Biella")
        return 8;
  else
  if(partProgram == "Fora3Biella")
        return 4;
  else
        return 1;
}



Object* Machine::doWork(Service* service)
{
  TRACE_FUNC("Machine::doWork");
  CBACK_TRACE(service,"Machine_doWork|_START_");
  GET_ARG(1,Piece,piece);
  GET_ARG(2,Symbol,partProg);
  assert(!input.isFull());
  input.add(piece);
  CBACK_TRACE(service,"Machine_doWork|2632180");
  service->setStatus(MacWaitWorkEmpty, &piece);
  CBACK_TRACE(service,"Machine_doWork|2825868");
  
  work.waitNotFull();
  work.add(piece);
  CBACK_TRACE(service,"Machine_doWork|2781380");
  
  input.remove(piece);
  CBACK_TRACE(service,"Machine_doWork|2017628");
  service->setStatus(MacStartWork, &piece);
  CBACK_TRACE(service,"Machine_doWork|3087884");
  
  waitFor(workTime(partProg));
  CBACK_TRACE(service,"Machine_doWork|2952756");
  service->setStatus(MacEndWork, &piece);
  CBACK_TRACE(service,"Machine_doWork|2960668");
  
  output.waitNotFull();
  output.add(piece);
  CBACK_TRACE(service,"Machine_doWork|2985868");
  
  work.remove(piece);
  CBACK_TRACE(service,"Machine_doWork|2080508");
  service->setStatus(MacOutFull, &piece);
  CBACK_TRACE(service,"Machine_doWork|3014236");
  
  output.waitForNot(piece);
  CBACK_TRACE(service,"Machine_doWork|3078244");

  CBACK_TRACE(service,"Machine_doWork|2538900");
  return nil;
}


Object* Machine::doRemovePiece(Service* service)
{
  TRACE_FUNC("Machine::doRemovePiece");
  CBACK_TRACE(service,"Machine_doRemovePiece|_START_");
  
  assert(!output.isEmpty());
  Piece* piece = CASTP(Piece,output.removeFirst());
  CBACK_TRACE(service,"Machine_doRemovePiece|2040772");

  CBACK_TRACE(service,"Machine_doRemovePiece|1930780");
  return piece;
}



Object* Machine::doService(Service* service)
{
  TRACE_FUNC("Machine::doService");
  GET_ARG(0,Symbol,servKind);
  if(&servKind == &MacDoWork)
	return doWork(service);
  else
  if(&servKind == &MacRemovePiece)
	return doRemovePiece(service);
  assert(0);
  return nil;
}



Service* Machine::joinWork(Piece* piece, Symbol* partProgram)
{
  return joinService(&MacDoWork,piece,partProgram);
}


Piece* Machine::waitRemovePiece()
{
  return CASTP(Piece,waitService(&MacRemovePiece));
}




Object* Machine::editorTrace(String& s)
{
  if(s == "input")
  {
	s = input.printOnString();
	return (Object*)&input;
  }
  else
  if(s == "work")
  {
	s = work.printOnString();
	return (Object*)&work;
  }
  else
  if(s == "output")
  {
	s = output.printOnString();
	return (Object*)&output;
  }
  return nil;
}

/* End of File Machine.C */

