/* File Machine.h  definition of ....*/
#ifndef MACHINE_H
#define MACHINE_H


#include <rodin/server.h>

#include <rodin/condcltn.h>
#include "Piece.h"



extern Symbol MacWaitWorkEmpty;
extern Symbol MacInNotFull;
extern Symbol MacStartWork;
extern Symbol MacEndWork;
extern Symbol MacOutFull;
extern Symbol OutFull;
extern Symbol InNotFull;
extern Symbol StartWork;
extern Symbol EndWork;

extern Class class_Machine;

class Machine : public Server
{
	DEFINE_CLASS_METHOD(Machine);
	DEFINE_IDLE_STORE_METHOD(Machine,Server);

  protected:

	CondCltn input;
	CondCltn work;
	CondCltn output;

  private:
	Time_t workTime(const Symbol& partProgram);
	virtual Object* doWork(Service* service);
	virtual Object* doRemovePiece(Service* service);

	Object* doService(Service* service);

  public:
	Machine(const char* name ="Machine", int inputSz =1);


	Service* joinWork(Piece* piece, Symbol* partProgram);
	Piece* waitRemovePiece();

	Object* editorTrace(String& member);

};

#endif /* MACHINE_H */

