/* File PeriferyIcon.C  implementation of class PeriferyIcon */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#define PERIFERYICON_C

#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>
#include <mondrian/widget.h>

#include "PeriferyIcon.h"

#include "RailIcon.h"
#include <mondrian/drawicon.h>
#include "RailPerifery.h"




#include <oak/orderedc.h>
#include <mondrian/compicon.h>



DEFINE_SIMPLE_CLASS(PeriferyIcon,IconNode,1,NULL);
#define THIS PeriferyIcon
#define BASE IconNode


void PeriferyIcon::storer(fileDescTy& fd) const
  { BASE::storer(fd); }

void PeriferyIcon::storer(ostream& strm) const
{
  TRACE_FUNC("PeriferyIcon::storer");
  BASE::storer(strm);
  icon_name.storeOn(strm);
  the_perifery->storeOn(strm);
  rail_icon->storeOn(strm);
}

PeriferyIcon::PeriferyIcon(fileDescTy& fd, PeriferyIcon& where)
  :BASE(fd,where)  { THIS_EQUAL_WHERE(where); } 

PeriferyIcon::PeriferyIcon(istream& strm, PeriferyIcon& where)
  :BASE(strm,where)
{
  THIS_EQUAL_WHERE(where);
  TRACE_FUNC("PeriferyIcon::FileConstructor");
  readFrom(strm,"String",icon_name);
  the_perifery = CASTP(RailPerifery,readFrom(strm));
  // rail_icon = (RailIcon*)nil;
  rail_icon = CASTP(RailIcon,readFrom(strm));
  select_icon = (DrawIcon*)nil;
}


PeriferyIcon::PeriferyIcon()
{
  TRACE_FUNC("PeriferyIcon::PeriferyIcon");
  the_perifery = (RailPerifery*)nil;
  select_icon = (DrawIcon*)nil;
  rail_icon = (RailIcon*)nil;
}




PeriferyIcon::~PeriferyIcon()
{
  TRACE_FUNC("PeriferyIcon::~PeriferyIcon");
}





void PeriferyIcon::createGeoIcon()
{
  TRACE_FUNC("PeriferyIcon::createGeoIcon");
  for(int i = 0; i < PERIF_I_W; i++)
        for(int j = 0; j < PERIF_I_H; j++)
                geo_icon->add( *new Point(i,j) );
}


void PeriferyIcon::createSemanticIcon()
{
  TRACE_FUNC("PeriferyIcon::createSemanticIcon");
  if(the_perifery != nil)
  {
	DrawIcon* icon = the_perifery->getIcon();
  	icon->x( -compIcon->x() + 0.5 );
  	icon->y( -compIcon->y() + 0.5 );
  	compIcon->add(*icon);
  }
}


void PeriferyIcon::destroySemanticIcon()
{
  TRACE_FUNC("PeriferyIcon::destroySemanticIcon");
}


void PeriferyIcon::modifyCommentIcon()
{
  TRACE_FUNC("PeriferyIcon::modifyCommentIcon");
  comment_icon->add(*new DrawString(icon_name,0,0 
	,0.8*icon_name.size() ) );
}


bool PeriferyIcon::hasComment()
{
  TRACE_FUNC("PeriferyIcon::hasComment");
  return YES;
}


void PeriferyIcon::buildParam(OrderedCltn& labels, OrderedCltn& values)
{
  TRACE_FUNC("PeriferyIcon::buildParam");
  if(labels.isEmpty())
  	labels.add(*new String("Icon Name >"));
  values.add(icon_name);
}


void PeriferyIcon::consumeParam(OrderedCltn& labels, OrderedCltn& values)
{
  TRACE_FUNC("PeriferyIcon::consumeParam");
  icon_name = icon_name.trim();
  labels.deleteAll();
  values.removeAll();
}


void PeriferyIcon::printOn(ostream& strm) const
{
  TRACE_FUNC("PeriferyIcon::printOn");
  BASE::printOn(strm);
}



void PeriferyIcon::addIcon(RailIcon* railIcon)
{
  TRACE_FUNC("PeriferyIcon::addIcon");
  DrawIcon* icon = the_perifery->setIcon(
				railIcon->rail());
  icon->x( -compIcon->x() + 0.5 );
  icon->y( -compIcon->y() + 0.5 );
  compIcon->add(*icon);
  rail_icon = railIcon;
  railIcon->addPeriferyIcon(this);
}


void PeriferyIcon::removeIcon()
{
  TRACE_FUNC("PeriferyIcon::removeIcon");
  assert(rail_icon != nil);
  DrawIcon* icon = the_perifery->getIcon();
  icon->x(0);
  icon->y(0);
  compIcon->remove(*icon);
  rail_icon->removePeriferyIcon(this);
  rail_icon = (RailIcon*)nil;
}




Object* PeriferyIcon::editorTrace(String& s)
{
  if(s == "select_icon")
  {
	s = select_icon->printOnString();
	return (Object*)select_icon;
  }
  else
  if(s == "the_perifery")
  {
	s = the_perifery->printOnString();
	return (Object*)the_perifery;
  }
  else
  if(s == "icon_name")
  {
	s = icon_name.printOnString();
	return (Object*)&icon_name;
  }
  else
  if(s == "rail_icon")
  {
	s = rail_icon->printOnString();
	return (Object*)rail_icon;
  }
  return nil;
}

/* End of File PERIFERYICON */

