/* File PeriferyIcon.h  definition of class PeriferyIcon */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#ifndef PERIFERYICON_H
#define PERIFERYICON_H

#include <editor/iconnode.h>

#include <oak/oakstrn.h>

class RailIcon;
class DrawIcon;
class RailPerifery;




#define PERIF_I_W 1
#define PERIF_I_H 1

#include <oak/orderedc.h>


extern Class class_PeriferyIcon;

class PeriferyIcon : public IconNode
{
	DEFINE_CLASS_METHOD(PeriferyIcon);

  protected:
	DrawIcon* select_icon;
	RailPerifery* the_perifery;
	String icon_name;
	RailIcon* rail_icon;


  protected:
	void storer(fileDescTy& fd) const;
	void storer(ostream& strm) const;
	PeriferyIcon(fileDescTy& fd, PeriferyIcon& where);
	PeriferyIcon(istream& strm, PeriferyIcon& where);

	virtual void createGeoIcon();
	virtual void createSemanticIcon();
	virtual void destroySemanticIcon();
	virtual void modifyCommentIcon();
	virtual bool hasComment();
	virtual void buildParam(OrderedCltn& labels, OrderedCltn& values);
	virtual void consumeParam(OrderedCltn& labels, OrderedCltn& values);
	virtual void printOn(ostream& strm) const;

  public:
	PeriferyIcon();
	~PeriferyIcon();


	virtual void addIcon(RailIcon* railIcon);
	virtual void removeIcon();

	Object* editorTrace(String& member);

};

#endif /* PERIFERYICON */

