/* File Rail.h  definition of ....*/
#ifndef RAIL_H
#define RAIL_H


#include <mondrian/compicon.h>

#include <oak/arrayob.h>
#include "RailPos.h"
#include "Rail.h"




extern Class class_Rail;

class Rail : public CompositeIcon
{
	DEFINE_CLASS_METHOD(Rail);

  protected:
	int next_rail;
	int from_rail;
	float rail_len;
	size_t sz;

	ArrayOb rails;
	ArrayOb posCltn;

  protected:
	void storer(fileDescTy& fd) const;
	void storer(ostream& strm) const;
	Rail(fileDescTy& fd, Rail& where);
	Rail(istream& strm, Rail& where);

	virtual void setGeometry(const RailPos& pos, int orient);
	virtual void setConnection(Rail* rail, int orient);
	virtual RailPos getConveyPos();
	void createMarker(const RailPos& pos);
	void removeConnect(Rail* rail);
	virtual void createIcon();

  public:
	Rail(double len =1);
	~Rail();


	Rail* setPos(const RailPos& pos, int orient =1);
	Rail* attachIn(int thisOrient, Rail* rail, int itsOrient);
	Rail* detachAt(int orient, int& attachOrient);
	Rail* railAt(int orient) const;
	RailPos& posAt(int orient) const;
	Rail* nextRail(Rail* from =(Rail*)nil);
	virtual int setFrom(Rail* rail);
	RailPos getCartPos();
	virtual RailPos getStationPos();
	void initAfterLoad();
	void printOn(ostream& strm) const;
	virtual size_t railCapacity() const;
	virtual size_t railSize() const;

	Object* editorTrace(String& member);

};

#endif /* RAIL_H */

