/* File RailIcon.C  implement ....*/
#define RAILICON_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "RailIcon.h"

#include "Rail.h"
#include <mondrian/drawicon.h>




#include <oak/orderedc.h>

String globalLenRail("1");


DEFINE_SIMPLE_CLASS(RailIcon,IconNode,1,NULL);
#define THIS RailIcon
#define BASE IconNode


void RailIcon::storer(fileDescTy& fd) const
  { BASE::storer(fd); }

void RailIcon::storer(ostream& strm) const
{
  TRACE_FUNC("RailIcon::storer");
  BASE::storer(strm);
  the_rail->storeOn(strm);
  where_con.storeOn(strm);
  rail_len.storeOn(strm);
  assocIcons.storeOn(strm);
}

RailIcon::RailIcon(fileDescTy& fd, RailIcon& where)
  :BASE(fd,where)  { THIS_EQUAL_WHERE(where); } 

RailIcon::RailIcon(istream& strm, RailIcon& where)
  :BASE(strm,where)
{
  THIS_EQUAL_WHERE(where);
  the_rail = CASTP(Rail,readFrom(strm));
  readFrom(strm,"String",where_con);
  readFrom(strm,"String",rail_len);
  readFrom(strm,"OrderedCltn",assocIcons);
  select_icon = (DrawIcon*)nil;
}


RailIcon::RailIcon()
  : where_con("1"), rail_len(globalLenRail)
{
  the_rail = (Rail*)nil;
  select_icon = (DrawIcon*)nil;
}




RailIcon::~RailIcon()
{
  TRACE_FUNC("RailIcon::~RailIcon");
}





void RailIcon::createGeoIcon()
{
  for(int i = 0; i < AGVI_W; i++)
        for(int j = 0; j < AGVI_H; j++)
                geo_icon->add( *new Point(i,j) );
}


void RailIcon::createSemanticIcon()
{
  select_icon = new DrawRect(0.3,0.3,0.4,0.4);
  compIcon->add(*select_icon);
  if(the_rail != nil)
  {
	the_rail->initAfterLoad();
	compIcon->add(*the_rail);
  }
}


void RailIcon::destroySemanticIcon()
{
  TRACE_FUNC("RailIcon::destroySemanticIcon");
}


void RailIcon::modifyCommentIcon()
{
  TRACE_FUNC("RailIcon::modifyCommentIcon");
}


bool RailIcon::hasComment()
{
  return NO;
}


void RailIcon::printOn(ostream& strm) const
{
  TRACE_FUNC("RailIcon::printOn");
  BASE::printOn(strm);
}


void RailIcon::buildParam(OrderedCltn& labels, OrderedCltn& values)
{
  if(isA() == &class_RailIcon)
  	labels.add(*new String("LineRail Parameter"));
  labels.add(*new String("Attach In (1 or 2) >"));
  labels.add(*new String("Length >"));
  values.add(where_con);
  values.add(rail_len);
}


void RailIcon::consumeParam(OrderedCltn& labels, OrderedCltn& values)
{
  rail_len = rail_len.trim();
  if(rail_len.value() == 0)
	rail_len = "1";

  where_con = where_con.trim();
  if(where_con.value() == 0)
	where_con = "2";

  if(the_rail == nil && isA() == &class_RailIcon)
	the_rail = new Rail(scaleFact * rail_len.value());
  labels.deleteAll();
  values.removeAll();
  if(isA() == &class_RailIcon)
  {
	globalLenRail = rail_len;
  }
}


OrderedCltn& RailIcon::getAssocIcon(OrderedCltn& cltn)
{
  TRACE_FUNC("RailIcon::getAssocIcon");
  cltn.addCltn(assocIcons);
  return cltn;
}



Rail* RailIcon::rail()
{
  return CASTP(Rail,the_rail);
}


int RailIcon::whereConnect()
{
  return int(where_con.value());
}


double RailIcon::railLen()
{
  return rail_len.value();
}


DrawIcon* RailIcon::selectIcon()
{
  TRACE_FUNC("RailIcon::selectIcon");
  return select_icon;
}


void RailIcon::addPeriferyIcon(PeriferyIcon* icon)
{
  TRACE_FUNC("RailIcon::addPeriferyIcon");
  assocIcons.add(*icon);
}


void RailIcon::removePeriferyIcon(PeriferyIcon* icon)
{
  TRACE_FUNC("RailIcon::removePeriferyIcon");
  assocIcons.remove(*icon);
}




Object* RailIcon::editorTrace(String& s)
{
  if(s == "the_rail")
  {
	s = the_rail->printOnString();
	return (Object*)the_rail;
  }
  else
  if(s == "rail_len")
  {
	s = rail_len.printOnString();
	return (Object*)&rail_len;
  }
  else
  if(s == "select_icon")
  {
	s = select_icon->printOnString();
	return (Object*)select_icon;
  }
  else
  if(s == "where_con")
  {
	s = where_con.printOnString();
	return (Object*)&where_con;
  }
  else
  if(s == "assocIcons")
  {
	s = assocIcons.printOnString();
	return (Object*)&assocIcons;
  }
  return nil;
}

/* End of File RAILICON */

