/* File RailIcon.h  definition of ....*/
#ifndef RAILICON_H
#define RAILICON_H


#include <editor/iconnode.h>

#include <oak/orderedc.h>
#include <oak/oakstrn.h>
#include "PeriferyIcon.h"

class Rail;
class DrawIcon;


#define AGVI_W 1
#define AGVI_H 1
#define scaleFact 4

#include <oak/orderedc.h>

extern Class class_RailIcon;

class RailIcon : public IconNode
{
	DEFINE_CLASS_METHOD(RailIcon);

  protected:
	Rail* the_rail;
	String rail_len;
	DrawIcon* select_icon;
	String where_con;

	OrderedCltn assocIcons;

  protected:
	void storer(fileDescTy& fd) const;
	void storer(ostream& strm) const;
	RailIcon(fileDescTy& fd, RailIcon& where);
	RailIcon(istream& strm, RailIcon& where);

	virtual void createGeoIcon();
	virtual void createSemanticIcon();
	virtual void destroySemanticIcon();
	virtual void modifyCommentIcon();
	virtual bool hasComment();
	virtual void printOn(ostream& strm) const;
	virtual void buildParam(OrderedCltn& labels, OrderedCltn& values);
	virtual void consumeParam(OrderedCltn& labels, OrderedCltn& values);
	OrderedCltn& getAssocIcon(OrderedCltn& cltn);

  public:
	RailIcon();
	~RailIcon();


	Rail* rail();
	int whereConnect();
	double railLen();
	DrawIcon* selectIcon();
	void addPeriferyIcon(PeriferyIcon* icon);
	void removePeriferyIcon(PeriferyIcon* icon);

	Object* editorTrace(String& member);

};

#endif /* RAILICON_H */

