/* File RailPos.h  definition of ....*/
#ifndef RAILPOS_H
#define RAILPOS_H


#include <oak/object.h>




#include <math.h>

#define TO_RAD(x) (x * 3.14159265358979323846 / 180)

double mod180(double ang);
double mod360(double ang);



extern Class class_RailPos;

class RailPos : public Object
{
	DEFINE_CLASS_METHOD(RailPos);


  private:
	float xc;
	float yc;
	float ang;

  protected:
	void storer(fileDescTy& fd) const;
	void storer(ostream& strm) const;
	RailPos(fileDescTy& fd, RailPos& where);
	RailPos(istream& strm, RailPos& where);


  public:
	RailPos(double x =0, double y =0, double angle =0);
	RailPos(const RailPos& pos);


	double x() const;
	double y() const;
	double angle() const;
	double radAngle() const;
	void operator=(const RailPos& pos);
	RailPos operator+(const RailPos& pos) const;
	RailPos operator-(const RailPos& pos) const;
	RailPos operator-() const;
	void printOn(ostream& strm) const;
	bool isEqual(const Object& ob) const;
	size_t hash() const;

	Object* editorTrace(String& member);

};

#endif /* RAILPOS_H */

