/* File SimpleStore.C  implement ....*/
#define SIMPLESTORE_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "SimpleStore.h"

#include "Piece.h"

#include <oak/cbacks.h>

// Symbol RemoveSignal = "RemoveSignal";
// Symbol FullSignal = "FullSignal";
  // RemoveSignal and FullSignal are events defined
  // in the VSeqCltn class.

bool raiseAny(const Cback_struct& cb)
{
  TRACE_FUNC("SimpleStore.C::raiseAny");
  CASTP(SimpleStore,cb.userData())
	->callCbacks(cb.name(),cb.callData());
  return YES;
}

DEFINE_SIMPLE_CLASS(SimpleStore,Server,1,NULL);
#define THIS SimpleStore
#define BASE Server


SimpleStore::SimpleStore(const char* name, int size)
  :BASE(name), buffer(size)
{
  TRACE_FUNC("SimpleStore::SimpleStore");
  buffer.addCback(AnyCback,raiseAny,this);
}



SimpleStore::~SimpleStore()
{
  TRACE_FUNC("SimpleStore::~SimpleStore");
  removeCback(AnyCback,raiseAny,this);
}





void SimpleStore::printOn(ostream& strm) const
{
  TRACE_FUNC("SimpleStore::printOn");
  strm << buffer << endl;
}



void SimpleStore::addPiece(Piece* piece)
{
  TRACE_FUNC("SimpleStore::addPiece");
  buffer.add(*piece);
}


Piece* SimpleStore::removePiece()
{
  TRACE_FUNC("SimpleStore::removePiece");
  return CASTP(Piece,buffer.removeFirst());
}


Piece* SimpleStore::firstPiece()
{
  TRACE_FUNC("SimpleStore::firstPiece");
  return CASTP(Piece,buffer.first());
}


void SimpleStore::deleteAllPiece()
{
  TRACE_FUNC("SimpleStore::deleteAllPiece");
  buffer.deleteAll();
}


void SimpleStore::resizePiece(size_t sz)
{
  TRACE_FUNC("SimpleStore::resizePiece");
  buffer.reSize(sz);
}


size_t SimpleStore::numberOfPiece() const
{
  TRACE_FUNC("SimpleStore::size");
  return buffer.size();
}




Object* SimpleStore::editorTrace(String& s)
{
  if(s == "buffer")
  {
	s = buffer.printOnString();
	return (Object*)&buffer;
  }
  return nil;
}

/* End of File SimpleStore.C */

