/* File StationIcon.C  implement ....*/
#define STATIONICON_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>
#include <mondrian/widget.h>

#include "StationIcon.h"

#include "RailIcon.h"
#include "Rail.h"
#include "Station.h"




#include <oak/orderedc.h>
#include <mondrian/compicon.h>



DEFINE_SIMPLE_CLASS(StationIcon,PeriferyIcon,1,NULL);
#define THIS StationIcon
#define BASE PeriferyIcon


void StationIcon::storer(fileDescTy& fd) const
  { BASE::storer(fd); }

void StationIcon::storer(ostream& strm) const
{
  TRACE_FUNC("StationIcon::storer");
  BASE::storer(strm);
}

StationIcon::StationIcon(fileDescTy& fd, StationIcon& where)
  :BASE(fd,where)  { THIS_EQUAL_WHERE(where); } 

StationIcon::StationIcon(istream& strm, StationIcon& where)
  :BASE(strm,where)
{
  THIS_EQUAL_WHERE(where);
  TRACE_FUNC("StationIcon::fileConstructor");
}


StationIcon::StationIcon()
{
  TRACE_FUNC("StationIcon::CartIcon");
}




StationIcon::~StationIcon()
{
  TRACE_FUNC("StationIcon::~CartIcon");
  delete the_perifery;
}





void StationIcon::createGeoIcon()
{
  TRACE_FUNC("StationIcon::createGeoIcon");
  for(int i = -1; i < PERIF_I_W - 1; i++)
        for(int j = 0; j < PERIF_I_H; j++)
                geo_icon->add( *new Point(i,j) );
}


void StationIcon::createSemanticIcon()
{
  TRACE_FUNC("StationIcon::createSemanticIcon");
  select_icon = new DrawRect(-0.7,0.1,0.4,0.8);
  compIcon->add(*select_icon);
  BASE::createSemanticIcon();
}


void StationIcon::destroySemanticIcon()
{
  TRACE_FUNC("StationIcon::destroySemanticIcon");
}


void StationIcon::buildParam(OrderedCltn& labels, OrderedCltn& values)
{
  TRACE_FUNC("StationIcon::buildParam");
  labels.add(*new String("Station Name >"));
  BASE::buildParam(labels,values);
}


void StationIcon::consumeParam(OrderedCltn& labels, OrderedCltn& values)
{
  TRACE_FUNC("StationIcon::consumeParam");
  BASE::consumeParam(labels,values);
  if(the_perifery == nil)
	the_perifery = new Station(icon_name);
  else
	CASTP(Station,the_perifery)->setName(icon_name);
}


void StationIcon::printOn(ostream& strm) const
{
  TRACE_FUNC("StationIcon::printOn");
  BASE::printOn(strm);
}



Station* StationIcon::station()
{
  TRACE_FUNC("StationIcon::cart");
  return CASTP(Station,the_perifery);
}




Object* StationIcon::editorTrace(String& )
{
  return nil;
}

/* End of File STATIONICON */

