/* File TurnIcon.C  implement ....*/
#define TURNICON_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "TurnIcon.h"

#include "TurnRail.h"


String globalAngTurn("30");
String globalRayTurn("2");

DEFINE_SIMPLE_CLASS(TurnIcon,RailIcon,1,NULL);
#define THIS TurnIcon
#define BASE RailIcon


void TurnIcon::storer(fileDescTy& fd) const
  { BASE::storer(fd); }

void TurnIcon::storer(ostream& strm) const
{
  TRACE_FUNC("TurnIcon::storer");
  BASE::storer(strm);
  rail_ang.storeOn(strm);
}

TurnIcon::TurnIcon(fileDescTy& fd, TurnIcon& where)
  :BASE(fd,where)  { THIS_EQUAL_WHERE(where); } 

TurnIcon::TurnIcon(istream& strm, TurnIcon& where)
  :BASE(strm,where)
{
  THIS_EQUAL_WHERE(where);
  readFrom(strm,"String",rail_ang);
}


TurnIcon::TurnIcon()
  : rail_ang(globalAngTurn)
{
  rail_len = globalRayTurn;
}



TurnIcon::~TurnIcon()
{
  TRACE_FUNC("TurnIcon::~TurnIcon");
}





void TurnIcon::buildParam(OrderedCltn& labels, OrderedCltn& values)
{
  if(isA() == &class_TurnIcon)
  	labels.add(*new String("TurnRail Parameter"));
  labels.add(*new String("Attach In (1 or 2) >"));
  labels.add(*new String("Ray >"));
  labels.add(*new String("Angle >"));
  values.add(where_con);
  values.add(rail_len);
  values.add(rail_ang);
}


void TurnIcon::consumeParam(OrderedCltn& labels, OrderedCltn& values)
{
  rail_len = rail_len.trim();
  if(rail_len.value() == 0)
	rail_len = "2";

  rail_ang = rail_ang.trim();
  if(rail_ang.value() == 0)
	rail_ang = "30";

  BASE::consumeParam(labels,values);

  if(the_rail == nil && isA() == &class_TurnIcon)
	the_rail = new TurnRail( rail_ang.value(),
			scaleFact * rail_len.value());

  if(isA() == &class_TurnIcon)
  {
    globalAngTurn = rail_ang;
    globalRayTurn = rail_len;
  }
}





Object* TurnIcon::editorTrace(String& s)
{
  if(s == "rail_ang")
  {
	s = rail_ang.printOnString();
	return (Object*)&rail_ang;
  }
  return nil;
}

/* End of File TurnIcon.C */

