/* File ATM.C  implement ....*/
#define ATM_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "ATM.h"

#include "cashCard.h"
#include "consortium.h"
#include <rodin/evnthdlr.h>
#include "remoteTrans.h"




#include <rodin/service.h>
#define waitEventFrom(event,server) service->waitEvent(event)

Symbol REQ_PASS = "REQ_PASS";
Symbol WT_ACK_PASS = "WT_ACK_PASS";
Symbol REQ_AMOUNT = "REQ_AMOUNT";
Symbol WT_ACK_AMNT = "WT_ACK_AMNT";
Symbol TRANS_MONEY = "TRANS_MONEY";
Symbol WRONG_PASS = "WRONG_PASS";
Symbol WRONG_CC = "WRONG_CC";
Symbol WRONG_AMNT = "WRONG_AMNT";
Symbol TIME_OUT = "TIME_OUT";

DEFINE_SIMPLE_CLASS(ATM,Server,1,NULL);
#define THIS ATM
#define BASE Server


ATM::ATM(const char* name, Consortium* consort)
:BASE(name), consortium(consort)
{
  TRACE_FUNC("ATM::ATM");
remTrans = new RemoteTransaction; 
uno = new Integer(1);
zero = new Integer(0);
}




ATM::~ATM()
{
  TRACE_FUNC("ATM::~ATM");
  delete remTrans;
  delete uno;
  delete zero;
}



bool ATM::consistent(CashCard* cc)
{
  TRACE_FUNC("ATM::consistent");
  cout << "not yet implemented" << endl;
  return NO;
}



Object* ATM::doService(Service* service)
{
  TRACE_FUNC("ATM::doService");
  CBACK_TRACE(service,"ATM_doService|_START_");
  
  GET_ARG(0,CashCard,card);
  remTrans->insertCard(card);
  Service* client = CASTP(Service,service->getClient());
  service->attachTo(client,AnyCback);
  Service* server = NULL;
  cout << "card Status " << card.status() << endl;
  CBACK_TRACE(service,"ATM_doService|277367512");
  if( card.status() == "OkCard" )
  {
      CBACK_TRACE(service,"ATM_doService|277377244");
      service->setStatus(REQ_PASS);
      SELECT_TRACE(service,"ATM_doService|13935620")
        ACCEPT(TRANSF_PASS);
          String* password = CASTP(String,service->callData());
          remTrans->insertPass(*password);
          CBACK_TRACE(service,"ATM_doService|14003620");
          server = consortium->joinService(remTrans);
          service->attachTo(server,AnyCback);
          CBACK_TRACE(service,"ATM_doService|277082068");

          CBACK_TRACE(service,"ATM_doService|20869996");
          service->setStatus(REQ_PASS, NULL);
          CONTINUE;
        ACCEPT(TIME_OUT);
          
          CBACK_TRACE(service,"ATM_doService|277415960");
          if( server == NULL )
          {
              CBACK_TRACE(service,"ATM_doService|20256036");
          }
          else
          {
              CBACK_TRACE(service,"ATM_doService|20256036");
              consortium->join(server);
              service->detachFrom(server,AnyCback);
              server = NULL;
              CBACK_TRACE(service,"ATM_doService|20453220");
          }
          
          retValue = zero;
          CBACK_TRACE(service,"ATM_doService|270325088");

          CBACK_TRACE(service,"ATM_doService|277636904");
          break;
        ACCEPT(WAIT_AMNT);
          
          CBACK_TRACE(service,"ATM_doService|272081696");
          service->setStatus(REQ_AMOUNT);
          SELECT_TRACE(service,"ATM_doService|13420340")
            ACCEPT(MONEY_OK);
              
              CBACK_TRACE(service,"ATM_doService|277689744");
              service->setStatus(TRANS_MONEY);
              CBACK_TRACE(service,"ATM_doService|278022752");
              
              retValue = uno;
              CBACK_TRACE(service,"ATM_doService|270336176");
            ACCEPT(TRANSF_AMNT);
              Integer* amount = CASTP(Integer,service->callData());
              cout << "ATM " << *amount << endl;
              CBACK_TRACE(service,"ATM_doService|23825092");
              service->setStatus(WT_ACK_AMNT, amount);

              CBACK_TRACE(service,"ATM_doService|12717500");
              service->setStatus(REQ_AMOUNT, amount);
              CONTINUE;
            ACCEPT(WRONG_AMNT);
              
              CBACK_TRACE(service,"ATM_doService|278135064");
              service->setStatus(WRONG_AMNT, NULL);

              CBACK_TRACE(service,"ATM_doService|13454108");
              service->setStatus(REQ_AMOUNT, NULL);
              CONTINUE;
          END_SELECT
          consortium->join(server);
          service->detachFrom(server,AnyCback);
          CBACK_TRACE(service,"ATM_doService|286340124");
        ACCEPT(WRONG_PASS);
          
          CBACK_TRACE(service,"ATM_doService|272063080");
          consortium->join(server);
          service->detachFrom(server,AnyCback);
          server = NULL;
          CBACK_TRACE(service,"ATM_doService|18085404");
          service->setStatus(WRONG_PASS, NULL);

          CBACK_TRACE(service,"ATM_doService|9224212");
          service->setStatus(REQ_PASS, NULL);
          CONTINUE;
      END_SELECT
  }
  else
  {
      CBACK_TRACE(service,"ATM_doService|277377244");
      service->setStatus(WRONG_CC);
      CBACK_TRACE(service,"ATM_doService|272297264");
      
      retValue = zero;
      CBACK_TRACE(service,"ATM_doService|269969060");
  }
  
  service->detachFrom(client,AnyCback);
  CBACK_TRACE(service,"ATM_doService|273506912");

  CBACK_TRACE(service,"ATM_doService|277133192");
  return retValue;
}






Object* ATM::editorTrace(String& s)
{
  if(s == "consortium")
  {
	s = consortium->printOnString();
	return (Object*)consortium;
  }
  else
  if(s == "remTrans")
  {
	s = remTrans->printOnString();
	return (Object*)remTrans;
  }
  return nil;
}

/* End of File ATM */

