/* File ATM.h  definition of ....*/
#ifndef ATM_H
#define ATM_H


#include <rodin/server.h>


class CashCard;
class Consortium;
class EventHandler;
class RemoteTransaction;




extern Symbol REQ_PASS;
extern Symbol WT_ACK_PASS;
extern Symbol REQ_AMOUNT;
extern Symbol WT_ACK_AMNT;
extern Symbol TRANS_MONEY;
extern Symbol WRONG_CC;
extern Symbol WRONG_PASS;
extern Symbol WRONG_AMNT;
extern Symbol TIME_OUT;
extern Symbol TRANSF_PASS;
extern Symbol WAIT_AMNT;
extern Symbol TRANSF_AMNT;

extern Class class_ATM;

class ATM : public Server
{
	DEFINE_CLASS_METHOD(ATM);
	DEFINE_IDLE_STORE_METHOD(ATM,Server);


  private:
	Consortium* consortium;

  protected:
	int cashOnHand;
	int code;
	int cashDispensed;
	Integer* uno, *zero, *retValue;
	RemoteTransaction* remTrans;


  private:
	bool consistent(CashCard* cc);
	virtual Object* doService(Service* service);

  public:
	ATM(const char* name ="TheATM", Consortium* consort =NULL);
	~ATM();



	Object* editorTrace(String& member);

};

#endif /* ATM */

