/* File cashCard.C  implement ....*/
#define CASHCARD_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "cashCard.h"







DEFINE_SIMPLE_CLASS(CashCard,Object,1,NULL);
#define THIS CashCard
#define BASE Object


CashCard::CashCard(int bankC, int cardC, int serialN)
{
  TRACE_FUNC("CashCard::CashCard");
  bankCode = bankC;
  cardCode = cardC;
  serialNumber = serialN;
}


CashCard::CashCard(const CashCard& card)
  :bankCode(card.bankCode)
  ,cardCode(card.cardCode)
  ,serialNumber(card.serialNumber)
  ,status_(card.status_)
{
  TRACE_FUNC("CashCard::CashCard");
}







void CashCard::printOn(ostream& strm) const
{
  TRACE_FUNC("CashCard::printOn");
  strm << bankCode << " " << cardCode << " " << serialNumber; 
}



int CashCard::bankCd()
{
  TRACE_FUNC("CashCard::bankCd");
  return bankCode;
}


int CashCard::cardCd()
{
  TRACE_FUNC("CashCard::cardCd");
  return cardCode;
}


int CashCard::serialNb()
{
  TRACE_FUNC("CashCard::serialNb");
  return serialNumber;
}


String& CashCard::status()
{
  TRACE_FUNC("CashCard::status");
  return status_;
}


void CashCard::status(const String& state)
{
  TRACE_FUNC("CashCard::status");
  status_ = state;
}


void CashCard::operator=(const CashCard& card)
{
  TRACE_FUNC("CashCard::operator=");
  bankCode = card.bankCode;
  cardCode = card.cardCode;
  serialNumber = card.serialNumber;
  status_ = card.status_;
}




Object* CashCard::editorTrace(String& s)
{
  if(s == "status_")
  {
	s = status_.printOnString();
	return (Object*)&status_;
  }
  return nil;
}

/* End of File CASHCARD */

