/* File client-GUI1.C  implement ....*/
#define CLIENT_GUI1_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "client-GUI1.h"

#include "ATM.h"
#include "cashCard.h"
#include <oak/integer.h>
#include <gui/CommandIcon.h>
#include <mondrian/graphic.h>
#include <gui/StringIcon.h>
#include <rodin/evnthdlr.h>
#include <oak/oakstrn.h>




#include <oak/oakstrm.h>

Symbol WAIT_ACK_CC = "WAIT_ACK_CC";
Symbol TRANSF_PASS = "TRANSF_PASS";
Symbol TRANSF_AMNT = "TRANSF_AMNT";
Symbol WAIT_GUI= "WAIT_GUI";


 
bool answerAction(const Cback_struct& cb)

{
   CASTP_OWNER(CommandIcon,btn);
   CASTP_USERDATA(Client,client);
   client->doChoice(btn);
   return YES;
}

DEFINE_SIMPLE_CLASS(Client,Server,1,NULL);
#define THIS Client
#define BASE Server


Client::Client(const char* name)
: BASE(name) 
{
  TRACE_FUNC("Client::Client");
  card = new CashCard(1111,0011,2200);
  amount = new Integer(1000000);
  cardStatus = new String("WrongCard");
  passwordStatus = new String("WrongPassword");
  amountStatus = new String("WrongAmount");
  box = new CppGraphic(topLevelWidget,"Box",NO);
  box->worldRect(FloatRec(0,0,800,600));
  box->absRect(FloatRec(0,0,400,300));

  OrderedCltn& iconCltn = *box->iconCltn();
  Istream strm("ATM.mim");
  readFrom(strm,"OrderedCltn",iconCltn);

  label1 = NULL;
  label2 = NULL; 
  okButton = NULL;
  notokButton = NULL;
  DO(iconCltn,DrawIcon,icon)
    if(icon->isKindOf(class_ActiveIcon))
    {
	String name = CASTP(ActiveIcon,icon)->name();
	if(name == "Message1")
  		label1 = CASTP(StringIcon,icon);
	else

	if(name == "Message2")
  		label2 = CASTP(StringIcon,icon);
	else
	if(name == "OkButton")
		okButton = CASTP(CommandIcon,icon);
	else
	if(name == "NotokButton")
		notokButton = CASTP(CommandIcon,icon);
    }
  OD
  assert(label1);
  assert(label2);
  assert(okButton);
  assert(notokButton);
  okButton->setIsSensitive(YES);
  okButton->addCback(CommandIconPress,answerAction,this);
  notokButton->setIsSensitive(YES);
  notokButton->addCback(CommandIconPress,answerAction,this);
}



Client::~Client()
{
  TRACE_FUNC("Client::~Client");
  delete amount;
  delete card;
  delete cardStatus;
  delete passwordStatus;
  delete amountStatus; 
}




Object* Client::doService(Service* service)
{
  TRACE_FUNC("Client::doService");
  CBACK_TRACE(service,"client-GUI1_doService|_START_");
  // Initialisation
  service->attachTo(myATM,AnyCback);
  int i = 0;
  bool passwdNotOk = YES;
  bool amountNotOk = YES;
  CBACK_TRACE(service,"client-GUI1_doService|271869228");

  CBACK_TRACE(service,"client-GUI1_doService|269146604");
  {  // START SUBNET client_Interaction
    CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|_START_");
    service->setStatus(WAIT_GUI);
    CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|269816376");
    
    waitEventFrom(CommandPress,i);
    CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|270714164");
  
    CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|270607968");
  }  //  END  SUBNET client_Interaction
  // request to ATM
  Service* server = myATM->joinService(card);
  CBACK_TRACE(service,"client-GUI1_doService|271966048");
  service->setStatus(WAIT_ACK_CC);
  SELECT_TRACE(service,"client-GUI1_doService|271883048")
    ACCEPT(REQ_PASS);
      i = 2;
      label1->setLabel("THE CARD IS FINE");
      CBACK_TRACE(service,"client-GUI1_doService|272285068");
      while (passwdNotOk)
      {
          CBACK_TRACE(service,"client-GUI1_doService|3078372");

          CBACK_TRACE(service,"client-GUI1_doService|271946668");
          {  // START SUBNET client_Interaction
            CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|_START_");
            service->setStatus(WAIT_GUI);
            CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|269816376");
            
            waitEventFrom(CommandPress,i);
            CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|270714164");
          
            CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|270607968");
          }  //  END  SUBNET client_Interaction
          service->setStatus(TRANSF_PASS, passwordStatus);
          SELECT_TRACE(service,"client-GUI1_doService|272312444")
            ACCEPT(REQ_AMOUNT);
              i = 4;
              passwdNotOk = NO;
              label1->setLabel("THE PASSWORD IS FINE");
              CBACK_TRACE(service,"client-GUI1_doService|272312732");
            ACCEPT(WRONG_PASS);
              label1->setLabel("THE PASSWORD IS WRONG");
              CBACK_TRACE(service,"client-GUI1_doService|272299004");
          END_SELECT
      }
      while (amountNotOk)
      {
          CBACK_TRACE(service,"client-GUI1_doService|6432812");

          CBACK_TRACE(service,"client-GUI1_doService|272121104");
          {  // START SUBNET client_Interaction
            CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|_START_");
            service->setStatus(WAIT_GUI);
            CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|269816376");
            
            waitEventFrom(CommandPress,i);
            CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|270714164");
          
            CBACK_TRACE(service,"client-GUI1_doService|client_Interaction|270607968");
          }  //  END  SUBNET client_Interaction
          service->setStatus(TRANSF_AMNT, amount);
          SELECT_TRACE(service,"client-GUI1_doService|271895848")
            ACCEPT(TRANS_MONEY);
              amountNotOk = NO;
              label1->setLabel("THE MONEY IS COMING");
              CBACK_TRACE(service,"client-GUI1_doService|271355084");
            ACCEPT(WRONG_AMNT);
              label1->setLabel("THE AMOUNT IS EXCESSIVE");
              CBACK_TRACE(service,"client-GUI1_doService|271335744");
          END_SELECT
      }
    ACCEPT(WRONG_CC);
      
      CBACK_TRACE(service,"client-GUI1_doService|271354764");
      label1->setLabel("THE CARD IS FAILED");
      CBACK_TRACE(service,"client-GUI1_doService|6060052");
  END_SELECT
  
  service->detachFrom(myATM,AnyCback);
  CBACK_TRACE(service,"client-GUI1_doService|272050228");

  CBACK_TRACE(service,"client-GUI1_doService|271362072");
  return myATM->join(server);
}



void Client::doChoice(CommandIcon* choiceButton)
{
  TRACE_FUNC("Client::doChoice");
// cout << "entrato" << endl;
//  assert(index >= 0);
// cout <<"assert ok" << endl;
   label2->setLabel("WAIT ACKNOWLEDGE");
  switch(choiceStatus)
  {
    case 0:
	if(choiceButton == notokButton)
	{
   		cardStatus = new String("WrongCard");
     		card->status(cardStatus);
	}
	else
	{
     		cardStatus = new String("CorrectCard");
	   	card->status(cardStatus);
	}
     	break;
    case 2:
	if(choiceButton == notokButton)
	{
   		passwordStatus = new String("WrongPassword");
	}
	else
	{
     		passwordStatus = new String("correctPassword");
	}
     	break;
    case 4:
	if(choiceButton == notokButton)
	{
   		amountStatus = new String("wrongAmount");
		*amount = 2000000;
	}
	else
	{
     		amountStatus = new String("CorrectAmount");
		*amount = 1000000; 
	}
     	break;
  }
}

void Client::waitEventFrom(const Symbol&,int choiceKind)
{
  TRACE_FUNC("Client::waitEventFrom");
  choiceStatus = choiceKind;
  activeProcess()->attachTo(okButton,CommandIconPress);
  activeProcess()->attachTo(notokButton,CommandIconPress);
  switch(choiceKind)
  {
     case 0: //wait card
	label2->setLabel("INSERT CARD");
	okButton->setLabel("Valid Card");
	notokButton->setLabel("Invalid Card");
	break;
     case 2: //wait password
        label2->setLabel("INSERT PASSWORD");
	okButton->setLabel("Correct Password");
	notokButton->setLabel("Wrong Password");
	break;
     case 4:
	label2->setLabel("INSERT AMOUNT");
	okButton->setLabel("Admissible Amount");
	notokButton->setLabel("Excessive Amount");
	break;
  }
  activeProcess()->waitEvent(CommandIconPress);
  activeProcess()->detachFrom(okButton,CommandIconPress);
  activeProcess()->detachFrom(notokButton,CommandIconPress);
}



void Client::assign(ATM* atm)
{
  TRACE_FUNC("Client::assign");
  myATM = atm;
}




Object* Client::editorTrace(String& s)
{
  if(s == "box")
  {
	s = box->printOnString();
	return (Object*)box;
  }
  else
  if(s == "label1")
  {
	s = label1->printOnString();
	return (Object*)label1;
  }
  else
  if(s == "okButton")
  {
	s = okButton->printOnString();
	return (Object*)okButton;
  }
  else
  if(s == "notokButton")
  {
	s = notokButton->printOnString();
	return (Object*)notokButton;
  }
  else
  if(s == "myATM")
  {
	s = myATM->printOnString();
	return (Object*)myATM;
  }
  else
  if(s == "amount")
  {
	s = amount->printOnString();
	return (Object*)amount;
  }
  else
  if(s == "card")
  {
	s = card->printOnString();
	return (Object*)card;
  }
  else
  if(s == "label2")
  {
	s = label2->printOnString();
	return (Object*)label2;
  }
  return nil;
}

/* End of File CLIENT_GUI1 */

