/* File client-GUI2.C  implement ....*/
#define CLIENT_GUI2_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "client-GUI2.h"

#include <gui/StringIcon.h>
#include "ATM.h"
#include <gui/CommandIcon.h>
#include <gui/GraphicKernel.h>




// #include <oak/oakstrm.h>

Symbol WAIT_ACK_CC = "WAIT_ACK_CC";
Symbol TRANSF_PASS = "TRANSF_PASS";
Symbol TRANSF_AMNT = "TRANSF_AMNT";
Symbol WAIT_GUI= "WAIT_GUI";


#ifdef IBM_RISC
void dummyFunc()
{
  new CommandIcon;
  new StringIcon;
}
#endif

 
bool getPasswdDigit(const Cback_struct& cb)
{
   CASTP_OWNER(CommandIcon,btn);
   CASTP_USERDATA(Client,client);
   client->passwdDigit(btn);
   return YES;
}

bool getAmountDigit(const Cback_struct& cb)
{
   CASTP_OWNER(CommandIcon,btn);
   CASTP_USERDATA(Client,client);
   client->amountDigit(btn);
   return YES;
}


DEFINE_SIMPLE_CLASS(Client,Server,1,NULL);
#define THIS Client
#define BASE Server


Client::Client(const char* name, ATM* theATM)
: BASE(name) 
, digits(10)
, card(1111,0011,2200)
, myATM(theATM)
{
  TRACE_FUNC("Client::Client");

  box = new GraphicKernel("ATM.mim");

  okCard = CASTP(CommandIcon,box->getIcon("OkCard"));
  wrongCard = CASTP(CommandIcon,box->getIcon("WrongCard")); 
  label1 = CASTP(StringIcon,box->getIcon("Message1"));
  label2 = CASTP(StringIcon,box->getIcon("Message2")); 
  sendButton = CASTP(CommandIcon,box->getIcon("sendCommand"));

  for(int i = 0; i <= 9; i++)
  {
	digits[i] = CASTP(CommandIcon,box->getIcon(form("d%d",i)));
  }
}



Client::~Client()
{
  TRACE_FUNC("Client::~Client");
}



void Client::end1(Object* commandChoice)
{
  TRACE_FUNC("Client::end1");
  if(commandChoice == okCard)
  {
	card.status("OkCard");
  }
  else
  {
	card.status("WrongCard");
  }
  okCard->setSensitive(NO);
  wrongCard->setSensitive(NO);
  label1->setLabel("");
  label2->setLabel("    WAIT ACKNOWLEDGE");
}


void Client::start2()
{
  TRACE_FUNC("Client::start2");
  label2->setLabel("    INSERT THE PASSWORD");
  assert(sendButton);
  sendButton->setSensitive(YES);
  DO(digits,CommandIcon,ic)
    ic->setSensitive(YES);
    ic->addCback(CommandIconPress,getPasswdDigit,this);
  OD
}


void Client::end2()
{
  TRACE_FUNC("Client::end2");
  passwordStatus = lastInput;
  lastInput = "";
  sendButton->setSensitive(NO);
  DO(digits,CommandIcon,ic)
    ic->setSensitive(NO);
    ic->removeCback(CommandIconPress,getPasswdDigit,this);
  OD
  label1->setLabel("");
  label2->setLabel("    WAIT ACKNOWLEDGE");
}


void Client::start3()
{
  TRACE_FUNC("Client::start3");
  label2->setLabel("     DESIRED AMOUNT");
  assert(sendButton);
  sendButton->setSensitive(YES);
  DO(digits,CommandIcon,ic)
    ic->setSensitive(YES);
    ic->addCback(CommandIconPress,getAmountDigit,this);
  OD
}


void Client::end3()
{
  TRACE_FUNC("Client::end3");
  amount = (int)lastInput.value();
  lastInput = "";
  sendButton->setSensitive(NO);
  DO(digits,CommandIcon,ic)
    ic->setSensitive(NO);
    ic->removeCback(CommandIconPress,getAmountDigit,this);
  OD
  label1->setLabel("");
  label2->setLabel("    WAIT ACKNOWLEDGE");
}


void Client::start1()
{
  TRACE_FUNC("Client::start");

  assert(okCard);
  assert(wrongCard);
  okCard->setSensitive(YES);
  wrongCard->setSensitive(YES);
  label2->setLabel("    INSERT THE CARD");
}


void Client::digit(CommandIcon* choiceButton)
{
  TRACE_FUNC("Client::choice");

  int index = digits.indexOf(*choiceButton);
  if(index >= 0 && index <= 9)
  {
	lastInput << index;
        cout << lastInput << endl; 
  }
  else
	cerr << "doChoice called for unexpected command" << endl;
}


void Client::passwdDigit(CommandIcon* choiceButton)
{
  TRACE_FUNC("Client::passwdDigit");
  digit(choiceButton);
  label1->setLabel("    INSERT THE PASSWORD");
  label2->setLabel("     " + String(lastInput.size(),'*'));
}


void Client::amountDigit(CommandIcon* choiceButton)
{
  TRACE_FUNC("Client::amountDigit");
  digit(choiceButton);
  label1->setLabel("     DESIRED AMOUNT");
  label2->setLabel("     " + lastInput);
}



Object* Client::doService(Service* service)
{
  TRACE_FUNC("Client::doService");
  CBACK_TRACE(service,"client-GUI2_doService|_START_");
  // Initialisation
  service->attachTo(myATM,AnyCback);
  bool passwdNotOk = YES;
  bool amountNotOk = YES;
  CBACK_TRACE(service,"client-GUI2_doService|271869228");

  CBACK_TRACE(service,"client-GUI2_doService|269146604");
  {  // START SUBNET client-GUI2_int1
    CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int1|_START_");
    //
    start1();
    service->attachTo(okCard,CommandIconPress);
    service->attachTo(wrongCard,CommandIconPress);
    CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int1|4356884");
    service->setStatus(WAIT_GUI);
    CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int1|4263124");
    
    service->waitEvent(CommandIconPress);
    end1(service->eventOwner());
    service->detachFrom(wrongCard,CommandIconPress);
    service->detachFrom(okCard,CommandIconPress);
    CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int1|4483548");
  
    CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int1|3639444");
  }  //  END  SUBNET client-GUI2_int1
  // request to ATM
  Service* server = myATM->joinService(&card);
  CBACK_TRACE(service,"client-GUI2_doService|271966048");
  service->setStatus(WAIT_ACK_CC);
  SELECT_TRACE(service,"client-GUI2_doService|271883048")
    ACCEPT(REQ_PASS);
      label1->setLabel("    THE CARD IS FINE");
      CBACK_TRACE(service,"client-GUI2_doService|272285068");
      while (passwdNotOk)
      {
          CBACK_TRACE(service,"client-GUI2_doService|3078372");

          CBACK_TRACE(service,"client-GUI2_doService|271946668");
          {  // START SUBNET client-GUI2_int2
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int2|_START_");
            //
            start2();
            service->attachTo(sendButton,CommandIconPress);
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int2|7190956");
            service->setStatus(WAIT_GUI);
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int2|6990164");
            
            service->waitEvent(CommandIconPress);
            service->detachFrom(sendButton,CommandIconPress);
            end2();
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int2|8560068");
          
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int2|3639444");
          }  //  END  SUBNET client-GUI2_int2
          service->setStatus(TRANSF_PASS, &passwordStatus);
          SELECT_TRACE(service,"client-GUI2_doService|272312444")
            ACCEPT(REQ_AMOUNT);
              passwdNotOk = NO;
              label1->setLabel("    THE PASSWORD IS FINE");
              CBACK_TRACE(service,"client-GUI2_doService|272312732");
            ACCEPT(WRONG_PASS);
              label1->setLabel("    THE PASSWORD IS WRONG");
              CBACK_TRACE(service,"client-GUI2_doService|272299004");
          END_SELECT
      }
      while (amountNotOk)
      {
          CBACK_TRACE(service,"client-GUI2_doService|6432812");

          CBACK_TRACE(service,"client-GUI2_doService|272121104");
          {  // START SUBNET client-GUI2_int3
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int3|_START_");
            //
            service->attachTo(sendButton,CommandIconPress);
            start3();
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int3|7190956");
            service->setStatus(WAIT_GUI);
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int3|6990164");
            
            service->waitEvent(CommandIconPress);
            service->detachFrom(sendButton,CommandIconPress);
            end3();
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int3|7997692");
          
            CBACK_TRACE(service,"client-GUI2_doService|client-GUI2_int3|3639444");
          }  //  END  SUBNET client-GUI2_int3
          service->setStatus(TRANSF_AMNT, &amount);
          SELECT_TRACE(service,"client-GUI2_doService|271895848")
            ACCEPT(TRANS_MONEY);
              amountNotOk = NO;
              label1->setLabel("    THE MONEY IS COMING");
              label2->setLabel("");
              CBACK_TRACE(service,"client-GUI2_doService|271355084");
            ACCEPT(WRONG_AMNT);
              label1->setLabel("   THE AMOUNT IS EXCESSIVE");
              CBACK_TRACE(service,"client-GUI2_doService|271335744");
          END_SELECT
      }
    ACCEPT(WRONG_CC);
      
      CBACK_TRACE(service,"client-GUI2_doService|271354764");
      label1->setLabel("    THE CARD IS FAILED");
      CBACK_TRACE(service,"client-GUI2_doService|6060052");
  END_SELECT
  
  service->detachFrom(myATM,AnyCback);
  CBACK_TRACE(service,"client-GUI2_doService|272050228");

  CBACK_TRACE(service,"client-GUI2_doService|271362072");
  return myATM->join(server);
}






Object* Client::editorTrace(String& s)
{
  if(s == "box")
  {
	s = box->printOnString();
	return (Object*)box;
  }
  else
  if(s == "label1")
  {
	s = label1->printOnString();
	return (Object*)label1;
  }
  else
  if(s == "label2")
  {
	s = label2->printOnString();
	return (Object*)label2;
  }
  else
  if(s == "sendButton")
  {
	s = sendButton->printOnString();
	return (Object*)sendButton;
  }
  else
  if(s == "okCard")
  {
	s = okCard->printOnString();
	return (Object*)okCard;
  }
  else
  if(s == "wrongCard")
  {
	s = wrongCard->printOnString();
	return (Object*)wrongCard;
  }
  else
  if(s == "passwordStatus")
  {
	s = passwordStatus.printOnString();
	return (Object*)&passwordStatus;
  }
  else
  if(s == "amount")
  {
	s = amount.printOnString();
	return (Object*)&amount;
  }
  else
  if(s == "card")
  {
	s = card.printOnString();
	return (Object*)&card;
  }
  else
  if(s == "myATM")
  {
	s = myATM->printOnString();
	return (Object*)myATM;
  }
  else
  if(s == "lastInput")
  {
	s = lastInput.printOnString();
	return (Object*)&lastInput;
  }
  else
  if(s == "digits")
  {
	s = digits.printOnString();
	return (Object*)&digits;
  }
  return nil;
}

/* End of File CLIENT_GUI2 */

