/* File client.C  implement ....*/
#define CLIENT_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "client.h"

#include "ATM.h"
#include "cashCard.h"
#include <oak/integer.h>
#include <rodin/evnthdlr.h>
#include <oak/oakstrn.h>




#define waitEventFrom(event,server) service->waitEvent()
Symbol WAIT_ACK_CC = "WAIT_ACK_CC";
Symbol TRANSF_PASS = "TRANSF_PASS";
Symbol TRANSF_AMNT = "TRANSF_AMNT";


DEFINE_SIMPLE_CLASS(Client,Server,1,NULL);
#define THIS Client
#define BASE Server


Client::Client(const char* name)
: BASE(name)
{
  TRACE_FUNC("Client::Client");
  card = new CashCard(1111,0011,2200);
  wrongPassword = new String("wrongPassword");
  correctPassword = new String("correctPassword");
  amount = new Integer(1000000);
 
}




Client::~Client()
{
  TRACE_FUNC("Client::~Client");
  delete card;
  delete wrongPassword;
  delete correctPassword; 
  delete amount;
}




Object* Client::doService(Service* service)
{
  TRACE_FUNC("Client::doService");
  CBACK_TRACE(service,"client_doService|_START_");
  
  service->attachTo(myATM,AnyCback);
  cout <<1 << endl;
  CBACK_TRACE(service,"client_doService|271869228");
  cout << *card << endl;
  Service* server = myATM->joinService(card);
  cout << 2 << endl;
  CBACK_TRACE(service,"client_doService|271966048");
  service->setStatus(WAIT_ACK_CC);
  SELECT_TRACE(service,"client_doService|271883048")
    ACCEPT(REQ_PASS);
      
      CBACK_TRACE(service,"client_doService|272285068");
      service->setStatus(TRANSF_PASS, correctPassword);
      SELECT_TRACE(service,"client_doService|272312444")
        ACCEPT(REQ_AMOUNT);
          
          cout << "client " << *amount << endl;
          CBACK_TRACE(service,"client_doService|272312732");
          service->setStatus(TRANSF_AMNT, amount);
          SELECT_TRACE(service,"client_doService|271895848")
            ACCEPT(TRANS_MONEY);
              
              CBACK_TRACE(service,"client_doService|271355084");
            ACCEPT(WRONG_AMNT);
              
              CBACK_TRACE(service,"client_doService|271335744");

              CBACK_TRACE(service,"client_doService|271870228");
              service->setStatus(TRANSF_AMNT, amount);
              CONTINUE;
          END_SELECT
        ACCEPT(WRONG_PASS);
          
          CBACK_TRACE(service,"client_doService|272299004");

          CBACK_TRACE(service,"client_doService|271934048");
          service->setStatus(TRANSF_PASS, correctPassword);
          CONTINUE;
      END_SELECT
    ACCEPT(WRONG_CC);
      
      CBACK_TRACE(service,"client_doService|271354764");

      CBACK_TRACE(service,"client_doService|273395784");
      break;
  END_SELECT
  myATM->join(server);
  service->detachFrom(myATM,AnyCback);
  CBACK_TRACE(service,"client_doService|272050228");

  CBACK_TRACE(service,"client_doService|271362072");
  return nil;
}




void Client::assign(ATM* atm)
{
  TRACE_FUNC("Client::assign");
  myATM = atm;
}




Object* Client::editorTrace(String& s)
{
  if(s == "card")
  {
	s = card->printOnString();
	return (Object*)card;
  }
  else
  if(s == "wrongPassword")
  {
	s = wrongPassword->printOnString();
	return (Object*)wrongPassword;
  }
  else
  if(s == "correctPassword")
  {
	s = correctPassword->printOnString();
	return (Object*)correctPassword;
  }
  else
  if(s == "amount")
  {
	s = amount->printOnString();
	return (Object*)amount;
  }
  else
  if(s == "myATM")
  {
	s = myATM->printOnString();
	return (Object*)myATM;
  }
  return nil;
}

/* End of File CLIENT */

