/* File consortium.C  implement ....*/
#define CONSORTIUM_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "consortium.h"

#include "bank.h"
#include <rodin/evnthdlr.h>
#include "remoteTrans.h"




#define waitEventFrom(event,server) service->waitEvent(event)

Symbol WAIT_AMNT = "WAIT_AMNT";
Symbol WAIT_BNK_OK = "WAIT_BNK_OK";
Symbol MONEY_OK = "MONEY_OK";


DEFINE_SIMPLE_CLASS(Consortium,Server,1,NULL);
#define THIS Consortium
#define BASE Server


Consortium::Consortium(const char* name, int bankCd)
:BASE(name)
{
  TRACE_FUNC("Consortium::Consortium");
   bank = new Bank("bankName", bankCd);
   bankCltn.add(*bank);
}




Consortium::~Consortium()
{
  TRACE_FUNC("Consortium::~Consortium");
  bankCltn.deleteAll();
}



Bank* Consortium::getBank(int bankCd)
{
  TRACE_FUNC("Consortium::getBank");
  IF_MATCH(
     EXIST(bankCltn,Bank, aBank,aBank->bankCd() == bankCd)
         return aBank;
       ENDEXIST
   )
}



Object* Consortium::doService(Service* service)
{
  TRACE_FUNC("Consortium::doService");
  CBACK_TRACE(service,"consortium_doService|_START_");
  
  GET_ARG(0,RemoteTransaction,remTrans);
  String password = remTrans.getPass();
  bank = getBank(remTrans.getBank());
  Service* client = CASTP(Service,service->getClient());
  service->attachTo(client,WT_ACK_AMNT);
  service->attachTo(bank,AnyCback);
  CBACK_TRACE(service,"consortium_doService|269146140");
  if( password == "12345" )
  {
      CBACK_TRACE(service,"consortium_doService|269511984");
      service->setStatus(WAIT_AMNT);
      CBACK_TRACE(service,"consortium_doService|269386996");
      // WT_ACK_AMNT
      waitEventFrom(WT_ACK_AMNT,client);
      Integer* amnt = CASTP(Integer,service->callData());
      remTrans.amount(*amnt);
      remTrans.amount(*amnt);
      CBACK_TRACE(service,"consortium_doService|269525160");
      service->setStatus(WAIT_BNK_OK);
      CBACK_TRACE(service,"consortium_doService|269539444");
      // Request to bank
      Integer ok = *CASTP(Integer,bank->waitService(&remTrans));
      CBACK_TRACE(service,"consortium_doService|269386748");
      if( ok )
      {
          CBACK_TRACE(service,"consortium_doService|269539004");
          service->setStatus(MONEY_OK);
          CBACK_TRACE(service,"consortium_doService|269717784");
      }
      else
      {
          CBACK_TRACE(service,"consortium_doService|269539004");
          service->setStatus(WRONG_AMNT);
          SELECT_TRACE(service,"consortium_doService|269551992")
            ACCEPT(WT_ACK_AMNT);
              amnt = CASTP(Integer,service->callData());
              remTrans.amount(*amnt);
              CBACK_TRACE(service,"consortium_doService|269828712");
              service->setStatus(WAIT_BNK_OK);
              CBACK_TRACE(service,"consortium_doService|269607648");
              // Request to bank
              Integer ok = *CASTP(Integer,bank->waitService(&remTrans));
              CBACK_TRACE(service,"consortium_doService|269607524");
              if( ok )
              {
                  CBACK_TRACE(service,"consortium_doService|269577368");
              }
              else
              {
                  CBACK_TRACE(service,"consortium_doService|269577368");

                  CBACK_TRACE(service,"consortium_doService|269524920");
                  service->setStatus(WRONG_AMNT, NULL);
                  CONTINUE;
              }
              service->setStatus(MONEY_OK);
              CBACK_TRACE(service,"consortium_doService|269386624");
            ACCEPT(TIME_OUT);
              
              CBACK_TRACE(service,"consortium_doService|269828588");

              CBACK_TRACE(service,"consortium_doService|270118568");
              break;
          END_SELECT
      }
  }
  else
  {
      CBACK_TRACE(service,"consortium_doService|269511984");
      
      CBACK_TRACE(service,"consortium_doService|271439968");
      service->setStatus(WRONG_PASS);
      CBACK_TRACE(service,"consortium_doService|269386872");
  }
  
  service->detachFrom(client,WT_ACK_AMNT);
  service->detachFrom(bank,AnyCback);
  CBACK_TRACE(service,"consortium_doService|270863852");

  CBACK_TRACE(service,"consortium_doService|269639620");
  return nil;
}






Object* Consortium::editorTrace(String& s)
{
  if(s == "bank")
  {
	s = bank->printOnString();
	return (Object*)bank;
  }
  else
  if(s == "bankCltn")
  {
	s = bankCltn.printOnString();
	return (Object*)&bankCltn;
  }
  return nil;
}

/* End of File CONSORTIUM */

