/* File factory-57.C  implement ....*/
#define FACTORY_57_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "factory-57.h"


Symbol FactoryProduction = "FactoryProduction";  
Symbol FactoryAssistance = "FactoryAssistance";  

DEFINE_SIMPLE_CLASS(Factory,Server,1,NULL);
#define THIS Factory
#define BASE Server


Factory::Factory(const char* name)
: BASE(name), shop(2)
{
  TRACE_FUNC("Factory::Factory");
}




Object* Factory::doService(Service* service)
{
  TRACE_FUNC("Factory::doService");
  GET_ARG(0,Symbol,servKind);  
  if(servKind == FactoryProduction)  
        return doProduction(service);  
  if(servKind == FactoryAssistance)  
        return doAssistance(service);  
  cerr << "Bad service kind " << servKind << endl;  
  assert(0); // create a run time error;  
  return nil;  
}



Object* Factory::doProduction(Service* service)
{
  TRACE_FUNC("Factory::doProduction");
  CBACK_TRACE(service,"factory-57_doProduction|_START_");
  GET_ARG(1,Order,order);
  order.status(OrderPlanned);
  orders.add(order);
  cout << "Start the service for Order " << order << endl;
  CBACK_TRACE(service,"factory-57_doProduction|269963860");
  service->setStatus(OrderPlanned, &order);
  CBACK_TRACE(service,"factory-57_doProduction|269900124");
  // waitAddOder
  shop.add(order);
  order.status(OrderInProgress);
  cout << "Order " << order << " is in progress" << endl;
  CBACK_TRACE(service,"factory-57_doProduction|269934280");
  service->setStatus(OrderInProgress, &order);
  CBACK_TRACE(service,"factory-57_doProduction|269918044");
  // WaitTime
  waitFor(order.getTime());
  shop.remove(order);
  orders.remove(order);
  order.status(OrderCompleted);
  cout << "Order " << order << " is complete" << endl;
  CBACK_TRACE(service,"factory-57_doProduction|269502156");

  CBACK_TRACE(service,"factory-57_doProduction|269963760");
  return nil;
}


Object* Factory::doAssistance(Service* service)
{
  TRACE_FUNC("Factory::doAssistance");
  CBACK_TRACE(service,"factory-57_doAssistance|_START_");
  GET_ARG(1,Order,order);
  order.status(OrderPlanned);
  assistanceCltn.add(order);
  cout << "Start the service for Order " << order << endl;
  CBACK_TRACE(service,"factory-57_doAssistance|269963860");
  service->setStatus(OrderPlanned, &order);
  CBACK_TRACE(service,"factory-57_doAssistance|269900124");
  // waitAddOder
  shop.add(order);
  order.status(OrderInProgress);
  cout << "Order " << order << " is in progress" << endl;
  CBACK_TRACE(service,"factory-57_doAssistance|269934280");
  service->setStatus(OrderInProgress, &order);
  CBACK_TRACE(service,"factory-57_doAssistance|269918044");
  // WaitTime
  waitFor(order.getTime());
  shop.remove(order);
  assistanceCltn.remove(order);
  order.status(OrderCompleted);
  cout << "Order " << order << " is completed" << endl;
  CBACK_TRACE(service,"factory-57_doAssistance|269502156");

  CBACK_TRACE(service,"factory-57_doAssistance|269963760");
  return nil;
}




void Factory::execProduction(Order* order)
{
  TRACE_FUNC("Factory::execProduction");
  execService(&FactoryProduction,order);  
}


void Factory::execAssistance(Order* order)
{
  TRACE_FUNC("Factory::execAssistance");
  execService(&FactoryAssistance,order);  
}




Object* Factory::editorTrace(String& s)
{
  if(s == "shop")
  {
	s = shop.printOnString();
	return (Object*)&shop;
  }
  else
  if(s == "orders")
  {
	s = orders.printOnString();
	return (Object*)&orders;
  }
  else
  if(s == "assistanceCltn")
  {
	s = assistanceCltn.printOnString();
	return (Object*)&assistanceCltn;
  }
  return nil;
}

/* End of File factory-57.C */

