/* File order-41.C  implement ....*/
#define ORDER_41_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "order-41.h"


      Symbol OrderReceived = "OrderReceived"; 
      Symbol OrderPlanned = "OrderPlanned"; 
      Symbol OrderInProgress = "OrderInProgress"; 
      Symbol OrderCompleted = "OrderCompleted"; 
      Symbol OrderDelivered = "OrderDelivered"; 

DEFINE_SIMPLE_CLASS(Order,Object,1,NULL);
#define THIS Order
#define BASE Object


Order::Order(const String& name, const Symbol& status)
:theName(name), theStatus(status)
{
  TRACE_FUNC("Order::Order");  
  if(theName == emptyString)
       theName = "Order";
}






void Order::printOn(ostream& strm) const
{
  TRACE_FUNC("Order::printOn");
  strm << theName << " " << theStatus; 

}



String Order::name()
{
  TRACE_FUNC("Order::name");
   return theName;
}


Symbol Order::status()
{
  TRACE_FUNC("Order::status");
   return theStatus;
}


void Order::status(Symbol newStatus)
{
  TRACE_FUNC("Order::status");
   theStatus = newStatus;
}




Object* Order::editorTrace(String& s)
{
  if(s == "theName")
  {
	s = theName.printOnString();
	return (Object*)&theName;
  }
  else
  if(s == "theStatus")
  {
	s = theStatus.printOnString();
	return (Object*)&theStatus;
  }
  return nil;
}

/* End of File order-41.C */

