/* File order-42.h  definition of class Order */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#ifndef ORDER_42_H
#define ORDER_42_H

#include <oak/object.h>

#include <oak/symbol.h>
#include <oak/oakstrn.h>





extern Symbol OrderReceived; 
extern Symbol OrderPlanned;
extern Symbol OrderInProgress; 
extern Symbol OrderCompleted;
extern Symbol OrderDelivered; 


extern Class class_Order;

class Order : public Object
{
	DEFINE_CLASS_METHOD(Order);
	DEFINE_IDLE_STORE_METHOD(Order,Object);

  private:
	String theName;
	Symbol theStatus;

  protected:
	virtual void printOn(ostream& strm) const;
	virtual bool isEqual(const Object& ob) const;
	virtual size_t hash() const;

  public:
	Order(const String& name =emptyString, const Symbol& status =OrderReceived);


	String name();
	Symbol status();
	void status(Symbol newStatus);

	Object* editorTrace(String& member);

};

#endif /* ORDER_42 */
