/* File order-43.C  implement ....*/
#define ORDER_43_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "order-43.h"


      Symbol OrderReceived = "OrderReceived"; 
      Symbol OrderPlanned = "OrderPlanned"; 
      Symbol OrderInProgress = "OrderInProgress"; 
      Symbol OrderCompleted = "OrderCompleted"; 
      Symbol OrderDelivered = "OrderDelivered"; 

DEFINE_SIMPLE_CLASS(Order,Object,1,NULL);
#define THIS Order
#define BASE Object


Order::Order(const String& name, const Symbol& status)
:theName(name), theStatus(status)
{
  TRACE_FUNC("Order::Order");  
  if(theName == emptyString)
       theName = "Order";
}






void Order::printOn(ostream& strm) const
{
  TRACE_FUNC("Order::printOn");
  strm << theName << " " << theStatus; 

}


bool Order::isEqual(const Object& ob) const
{
  TRACE_FUNC("Order::isEqual");
   if(ob.isKindOf(class_Order))
   {
     Order* ord = (Order*)&ob; 
     return theStatus == ord->theStatus; 
   } 
   else 
   if(ob.isKindOf(class_Symbol)) 
   { 
     Symbol* sym = (Symbol*)&ob; 
     return theStatus == *sym; 
   } 
   else 
   if(ob.isKindOf(class_String)) 
   { 
     String* nam = (String*)&ob; 
     return theStatus == *nam; 
   } 
   else 
     return NO; 
}


int Order::compare(const Object& ob) const
{
  TRACE_FUNC("Order::compare");
   assertArgKind(ob,class_Order,"compare"); 
          // verify that ob is an Order 
  Order& ord = *(Order*)&ob; 
          return theName.compare(ord.theName); 

}



String Order::name()
{
  TRACE_FUNC("Order::name");
   return theName;
}


Symbol Order::status()
{
  TRACE_FUNC("Order::status");
   return theStatus;
}


void Order::status(Symbol newStatus)
{
  TRACE_FUNC("Order::status");
   theStatus = newStatus;
}




Object* Order::editorTrace(String& s)
{
  if(s == "theName")
  {
	s = theName.printOnString();
	return (Object*)&theName;
  }
  else
  if(s == "theStatus")
  {
	s = theStatus.printOnString();
	return (Object*)&theStatus;
  }
  return nil;
}

/* End of File order-43.C */

