/* File topLevel-51.C  implement ....*/
#define TOPLEVEL_51_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "topLevel-51.h"

#include <oak/orderedc.h>

#include <oak/oakstrm.h> 
#include <rodin/oakproc.h> 

bool orderPlannedFunc(const Cback_struct& cb) 
 { 
   cout << "Callback raised by owner " << *cb.owner() << endl; 
   cout << "Callback name = " << cb.name() << endl; 
   cout << "User Data = " << *cb.userData() << endl; 
   cout << "Call Data = " << *cb.callData() << endl; 
   return YES; 
 }
 
bool vseqCltnFunc(const Cback_struct& cb) 
{ 
   cout << "Callback name = " << cb.name() << endl; 
   cout << "Callback raised by owner " << cb.owner()->className() 
        << endl; 
   if(cb.callData() != NULL) 
       cout << "Call Data = " << *cb.callData() << endl; 
   return YES; 
}
main(int,char**) 
{ 
   TopLevel* topLevel = new TopLevel; 
   topLevel->doIt(); 
   delete topLevel; 
   return 0; 
}
DEFINE_SIMPLE_CLASS(TopLevel,Object,1,NULL);
#define THIS TopLevel
#define BASE Object


TopLevel::TopLevel()
  : orders(class_OrderedCltn) 
    // the constructor of orders is invoked, 
    // an OrderedCltn is passed 

{
  TRACE_FUNC("TopLevel::TopLevel");
   orders.addCback(AnyCback,vseqCltnFunc); 
     // any event is monitored 

}






void TopLevel::insertError()
{
  TRACE_FUNC("TopLevel::insertError");
  Order automaticOrder("OrderA"); 
  orders.add(automaticOrder); 
  cout << "All orders are " << orders << endl; 
  // forgot to remove automaticOrder 

}



void TopLevel::doIt()
{
  TRACE_FUNC("TopLevel::doIt");
  int mainPriority = mainProcess->priority();  
            // mainProcess default process of the environment  
            // it starts with priority = 0  
  
  Process* secondProcess = new Process("SecondProcess",mainPriority);  
     // create another process with the same priority than mainProcess  
  
  FORK(secondProcess)  // the process SecondProcess is forked  
     cout << "Active Process is " << *activeProcess() << endl;  
     Order* order = CASTP(Order,orders.removeFirst());  
     cout << "Order removed is " << *order << endl;  
     delete order;  
     cout << "The state of all present processes is" << endl;  
     cout << *scheduler << endl;  
  
     cout << "Now SecondProcess terminates" << endl;  
  ENDFORK  
  
  cout << "Main Process continues after forking the SecondProcess"  
          << endl;  
  cout << "Active Process is " << *activeProcess() << endl;  
  orders.add(*new Order("Order1"));  
  cout << "Main process suspends itself and SecondProcess can start"  
            << endl;  
  mainProcess->setPriority(mainPriority - 1);  
     // priority is reduced  
  cout << "Main Process runs again after SecondProcess Termination"  
       << endl;  
  delete secondProcess;  
}




Object* TopLevel::editorTrace(String& s)
{
  if(s == "orders")
  {
	s = orders.printOnString();
	return (Object*)&orders;
  }
  return nil;
}

/* End of File topLevel-51.C */

