/* File topLevel-53.C  implementation of class TopLevel */

/*		Copyright (c) 1990 SYCO			  */
/*		  All Rights Reserved			  */
/*							  */
/*  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SYCO   */
/*  The copyright notice above does not evidence any      */
/*  actual or intended publication of such source code.   */


#define TOPLEVEL_53_C

#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "topLevel-53.h"

#include <oak/orderedc.h>




#include <oak/oakstrm.h> 
#include <rodin/oakproc.h> 

bool orderPlannedFunc(const Cback_struct& cb) 
 { 
   cout << "Callback raised by owner " << *cb.owner() << endl; 
   cout << "Callback name = " << cb.name() << endl; 
   cout << "User Data = " << *cb.userData() << endl; 
   cout << "Call Data = " << *cb.callData() << endl; 
   return YES; 
 }
 
bool vseqCltnFunc(const Cback_struct& cb) 
{ 
   cout << "Callback name = " << cb.name() << endl; 
   cout << "Callback raised by owner " << cb.owner()->className() 
        << endl; 
   if(cb.callData() != NULL) 
       cout << "Call Data = " << *cb.callData() << endl; 
   return YES; 
}
main(int,char**) 
{ 
   TopLevel* topLevel = new TopLevel; 
   topLevel->doIt(); 
   delete topLevel; 
   return 0; 
}

DEFINE_SIMPLE_CLASS(TopLevel,Object,1,NULL);
#define THIS TopLevel
#define BASE Object


TopLevel::TopLevel()
  : orders(class_OrderedCltn) 
    // the constructor of orders is invoked, 
    // an OrderedCltn is passed 

{
  TRACE_FUNC("TopLevel::TopLevel");
   orders.addCback(AnyCback,vseqCltnFunc); 
     // any event is monitored 

}







void TopLevel::insertError()
{
  TRACE_FUNC("TopLevel::insertError");
  Order automaticOrder("OrderA"); 
  orders.add(automaticOrder); 
  cout << "All orders are " << orders << endl; 
  // forgot to remove automaticOrder 

}



void TopLevel::doIt()
{
  TRACE_FUNC("TopLevel::doIt");
  int mainPriority = mainProcess->priority();  
  
  Process* secondProcess = new Process("SecondProcess",  
      mainPriority+1);  
  // secondProcess has a greater priority than mainProcess  
  
  cout << "Main Process before a FORK of the SecondProcess" << endl;  
  FORK(secondProcess)  
     cout << "Active Process is " << *activeProcess() << endl;  
  
     ev.attachTo(&orders,AddSignal);  
     ev.attachTo(&orders,RemoveSignal);  
  
     cout << "SecondProcess waits for AddSignal" << endl;  
     SELECT(&ev)  
       ACCEPT(AddSignal)  
          Order* order = CASTP(Order,orders.removeFirst());  
          cout << "the Order removed is " << *order << endl;  
          delete order;  
          CONTINUE;  
  
       ACCEPT(RemoveSignal)  
          cout << "The state of all present processes is" << endl;  
          cout << *scheduler << endl;  
  
     END_SELECT  
     ev.detachFrom(&orders,AddSignal);  
     ev.detachFrom(&orders,RemoveSignal);  
     cout << "SecondProcess Terminates Now" << endl;  
  ENDFORK  
  
  cout << "Main Process continues after SecondProcess waitEvent"  
       << endl;  
  cout << "Active Process is " << *activeProcess() << endl;  
  cout << "Main process suspends itself and SecondProcess starts"  
            << endl;  
  orders.add(*new Order("Order1"));  
  mainProcess->setPriority(mainPriority - 1);  
  cout << "Main Process runs again after SecondProcess Termination"  
       << endl;  
  
  delete secondProcess;  
}




Object* TopLevel::editorTrace(String& s)
{
  if(s == "ev")
  {
	s = ev.printOnString();
	return (Object*)&ev;
  }
  else
  if(s == "orders")
  {
	s = orders.printOnString();
	return (Object*)&orders;
  }
  return nil;
}

/* End of File TOPLEVEL_53 */
