/* File topLevel-54.C  implement ....*/
#define TOPLEVEL_54_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "topLevel-54.h"

#include <oak/orderedc.h>

#include <oak/oakstrm.h> 
#include <rodin/oakproc.h> 

bool orderPlannedFunc(const Cback_struct& cb) 
 { 
   cout << "Callback raised by owner " << *cb.owner() << endl; 
   cout << "Callback name = " << cb.name() << endl; 
   cout << "User Data = " << *cb.userData() << endl; 
   cout << "Call Data = " << *cb.callData() << endl; 
   return YES; 
 }
 
bool vseqCltnFunc(const Cback_struct& cb) 
{ 
   cout << "Callback name = " << cb.name() << endl; 
   cout << "Callback raised by owner " << cb.owner()->className() 
        << endl; 
   if(cb.callData() != NULL) 
       cout << "Call Data = " << *cb.callData() << endl; 
   return YES; 
}
main(int,char**) 
{ 
   TopLevel* topLevel = new TopLevel; 
   topLevel->doIt(); 
   delete topLevel; 
   return 0; 
}
DEFINE_SIMPLE_CLASS(TopLevel,Object,1,NULL);
#define THIS TopLevel
#define BASE Object


TopLevel::TopLevel()
  : orders(2) 
    // the constructor of orders is invoked, 
    // only two slots are available in orders   

{
  TRACE_FUNC("TopLevel::TopLevel");
   orders.addCback(AnyCback,vseqCltnFunc); 
     // any event is monitored 
}






void TopLevel::insertError()
{
  TRACE_FUNC("TopLevel::insertError");
  Order automaticOrder("OrderA"); 
  orders.add(automaticOrder); 
  cout << "All orders are " << orders << endl; 
  // forgot to remove automaticOrder 

}



void TopLevel::doIt()
{
  TRACE_FUNC("TopLevel::doIt");
  int mainPriority = mainProcess->priority();  
        // mainProcess is the first process of the environment  
        // it starts with priority = 0  
  
  Process* secondProcess = new Process("SecondProcess",  
      mainPriority + 1);  
     // another process  
     // with a higher priority than mainProcess is created  
  
  cout << "Main Process before FORK SecondProcess" << endl;  
  FORK(secondProcess)  // the process SecondProcess starts  
    cout <<  
       "SecondProcess starts after FORK, having a greater priority"  
            << endl;  
  
     cout << "Active Process is " << *activeProcess() << endl;  
     cout <<  
        "Second Process suspends itself because orders is empty"  
          << endl;  
     Order* order = CASTP(Order,orders.removeFirst());  
     cout << "Order removed is " << *order << endl;  
     delete order;  
     order = CASTP(Order,orders.removeFirst());  
     cout << "Order removed is " << *order << endl;  
     delete order;  
     order = CASTP(Order,orders.removeFirst());  
     cout << "Order removed is " << *order << endl;  
     delete order;  
     order = CASTP(Order,orders.removeFirst());  
     cout << "Order removed is " << *order << endl;  
     delete order;  
  
     cout << "SecondProcess has terminated its statement"  
          << endl;  
  ENDFORK  
  
  cout << "Main Process continues after suspension of SecondProcess"  
       << endl;  
  cout << "Active Process is " << *activeProcess() << endl;  
  orders.add(*new Order("Order1"));  
  mainProcess->setPriority(mainPriority + 2);  
  cout << "Main process raises its priority" << endl;  
  orders.add(*new Order("Order2"));  
  orders.add(*new Order("Order3"));  
  orders.add(*new Order("Order4"));  
  cout << "Main Process has terminated its statement" << endl;  
  mainProcess->setPriority(mainPriority);  
  delete secondProcess;  

}




Object* TopLevel::editorTrace(String& s)
{
  if(s == "ev")
  {
	s = ev.printOnString();
	return (Object*)&ev;
  }
  else
  if(s == "orders")
  {
	s = orders.printOnString();
	return (Object*)&orders;
  }
  return nil;
}

/* End of File topLevel-54.C */

