/* File topLevel-56.C  implement ....*/
#define TOPLEVEL_56_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "topLevel-56.h"

#include "./order-55.h"
#include <oak/orderedc.h>

#include <oak/oakstrm.h> 
#include <rodin/oakproc.h> 
#include <rodin/service.h>
bool orderPlannedFunc(const Cback_struct& cb) 
 { 
   cout << "Callback raised by owner " << *cb.owner() << endl; 
   cout << "Callback name = " << cb.name() << endl; 
   cout << "User Data = " << *cb.userData() << endl; 
   cout << "Call Data = " << *cb.callData() << endl; 
   return YES; 
 }

 bool factoryChanged(const Cback_struct& cb)  
{  
   cout << "TIME: " << currentTime() << ", Status = "  
                    << cb.name();  
   Object* data = cb.callData();  
   if(data->isKindOf(class_Order))  
       cout << " Order " << *data << endl;  
   else  
   if(data->isKindOf(class_Service))  
       cout << " Order " << *((Service*)data)->getArg(0)  
            << endl;  
   return YES;  
 }

main(int,char**) 
{ 
   TopLevel* topLevel = new TopLevel; 
   topLevel->doIt(); 
   delete topLevel; 
   return 0; 
}
DEFINE_SIMPLE_CLASS(TopLevel,Object,1,NULL);
#define THIS TopLevel
#define BASE Object


TopLevel::TopLevel()
  : factory("Factory")
    // the constructor of factory is invoked, 
    // with name Factory

{
  TRACE_FUNC("TopLevel::TopLevel");
   factory.addCback(AnyCback,factoryChanged); 
     // any event is monitored 
}







void TopLevel::doIt()
{
  TRACE_FUNC("TopLevel::doIt");
  Order* o1 = new Order("Order1",OrderReceived,10);  
  Service* s1 = factory.joinService(o1);  
  Order* o2 = new Order("Order2",OrderReceived,15);  
  Service* s2 = factory.joinService(o2);  
  Order* o3 = new Order("Order3",OrderReceived,10);  
  Service* s3 = factory.joinService(o3);  
  Order* o4 = new Order("Order4",OrderReceived,20);  
  Service* s4 = factory.joinService(o4);  
  
factory.join(s1);  
factory.join(s2);  
factory.join(s3);  
factory.join(s4);  

  delete o1;  
  delete o2;  
  delete o3;  
  delete o4;  

}




Object* TopLevel::editorTrace(String& s)
{
  if(s == "ev")
  {
	s = ev.printOnString();
	return (Object*)&ev;
  }
  else
  if(s == "factory")
  {
	s = factory.printOnString();
	return (Object*)&factory;
  }
  return nil;
}

/* End of File topLevel-56.C */

