/* File topLevel-61.C  implement ....*/
#define TOPLEVEL_61_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "topLevel-61.h"

#include <mondrian/command.h>

bool commandFunc(const Cback_struct& cb) 
{ 
   static bool doQuit = NO; 
 
   CASTP_OWNER(CppCommand,button); 
   if(doQuit) 
        exitMainLoop(); 
   else 
   { 
        doQuit = YES; 
        button->label("Hit this button once more"); 
   } 
   return YES; 
} 
 
main(int,char**) 
{ 
  TopLevel* toplevel = new TopLevel; 
  toplevel->doIt(); 
  delete toplevel; 
  return 0; 
} 

DEFINE_SIMPLE_CLASS(TopLevel,Object,1,NULL);
#define THIS TopLevel
#define BASE Object


TopLevel::TopLevel()
{
  TRACE_FUNC("TopLevel::TopLevel");
  button = new CppCommand(topLevelWidget,"button"); 
  button->label("Hit this button for quitting"); 
  button->addCback(CommandPress,commandFunc); 

}



TopLevel::~TopLevel()
{
  TRACE_FUNC("TopLevel::~TopLevel");
  delete button;
}






TopLevel::doIt()
{
  TRACE_FUNC("TopLevel::doIt");
  baseMainLoop();
}




Object* TopLevel::editorTrace(String& s)
{
  if(s == "button")
  {
	s = button->printOnString();
	return (Object*)button;
  }
  return nil;
}

/* End of File topLevel-61.C */

