/* File topLevel-62.C  implement ....*/
#define TOPLEVEL_62_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>

#include "topLevel-62.h"

#include <mondrian/box.h>

bool commandFunc(const Cback_struct& cb) 
{ 
   CASTP_OWNER(CppCommand,button); 
   CASTP_USERDATA(TopLevel,toplevel); 
   toplevel->doChoice(button);
   return YES;
} 
 
main(int,char**) 
{ 
  TopLevel* toplevel = new TopLevel; 
  toplevel->doIt(); 
  delete toplevel; 
  return 0; 
} 

DEFINE_SIMPLE_CLASS(TopLevel,Object,1,NULL);
#define THIS TopLevel
#define BASE Object


TopLevel::TopLevel()
{
  TRACE_FUNC("TopLevel::TopLevel");
   box = new CppBox(topLevelWidget,"box"); 
 
   CppCommand* button = new CppCommand(box,"button1"); 
   button->label("Choice 1"); 
   buttons.add(*button); 
 
   button = new CppCommand(box,"button2"); 
   button->label("Choice 2"); 
   buttons.add(*button); 
 
   button = new CppCommand(box,"button3"); 
   button->label("Quit"); 
   buttons.add(*button); 
 
   DO(buttons,CppCommand,button) 
         button->addCback(CommandPress,commandFunc,this); 
   OD 

}



TopLevel::~TopLevel()
{
  TRACE_FUNC("TopLevel::~TopLevel");
  deleteWidget(box);
}





void TopLevel::doChoice(CppCommand*choice)
{
  TRACE_FUNC("TopLevel::doChoice"); 
  int index = buttons.indexOf(*choice); 
  assert(index >= 0); 
  switch(index) 
  { 
    case 0: 
        if(choice->label().right(1) == "1") 
                choice->label("Choice 3"); 
        else 
                choice->label("Choice 1"); 
        break; 
    case 1: 
        if(choice->label().right(1) == "2") 
                choice->label("Choice 4"); 
        else 
                choice->label("Choice 2"); 
        break; 
    default: 
        exitMainLoop(); 
  }
}



void TopLevel::doIt()
{
  TRACE_FUNC("TopLevel::doIt");
  baseMainLoop();
}




Object* TopLevel::editorTrace(String& s)
{
  if(s == "box")
  {
	s = box->printOnString();
	return (Object*)box;
  }
  else
  if(s == "buttons")
  {
	s = buttons.printOnString();
	return (Object*)&buttons;
  }
  return nil;
}

/* End of File topLevel-62.C */

