/* File topLevel-63.h  definition of ....*/
#ifndef TOPLEVEL_63_H
#define TOPLEVEL_63_H


#include <oak/object.h>

#include <mondrian/command.h>
#include <oak/orderedc.h>
#include <oak/symbol.h>

class CppPushButton;
class DrawIcon;
class WorldCursor;
class CppBox;
class CppForm;
class CppGraphic;
class DrawRect;



extern Class class_TopLevel;

class TopLevel : public Object
{
	DEFINE_CLASS_METHOD(TopLevel);
	DEFINE_IDLE_STORE_METHOD(TopLevel,Object);

friend bool setToInsertFunc(const Cback_struct& cb); 
friend bool setToMoveFunc(const Cback_struct& cb); 
friend bool graphDownFunc(const Cback_struct& cb); 
friend bool graphMoveFunc(const Cback_struct& cb); 
friend bool graphUpFunc(const Cback_struct& cb); 


  private:
	CppBox* box;
	CppForm* base;
	CppGraphic* graph;
	Symbol state;
	DrawIcon* moveObject;

  protected:

	OrderedCltn buttons;

	void setToInsert();
	void setToMove();
	void graphDown(WorldCursor* cur);
	void graphMove(WorldCursor* cur);
	void graphUp(WorldCursor* cur);

  public:
	TopLevel();
	~TopLevel();


	void doIt();

	Object* editorTrace(String& member);

};

#endif /* TOPLEVEL-63_H */

