/* File topLevel-72.C  implement ....*/
#define TOPLEVEL_72_C


#include <oak/oakstrn.h>
#include <oak/symbol.h>
#include <oak/cbacks.h>
#include <mondrian/widget.h>

#include "topLevel-72.h"

#include <mondrian/box.h>
#include <mondrian/command.h>
#include <oak/orderedc.h>
#include "./order-55.h"

#include <mondrian/animation.h> 
#include <oak/oakstrm.h> 
#include <rodin/oakproc.h> 
#include <rodin/service.h>

bool orderPlannedFunc(const Cback_struct& cb) 
{ 
   cout << "Callback raised by owner " << *cb.owner() << endl; 
   cout << "Callback name = " << cb.name() << endl; 
   cout << "User Data = " << *cb.userData() << endl; 
   cout << "Call Data = " << *cb.callData() << endl; 
   return YES; 
}

bool factoryChanged(const Cback_struct& cb)  
{  
   cout << "TIME: " << currentTime() << ", Status = "  
                    << cb.name();  
   Object* data = cb.callData();  
   if(data->isKindOf(class_Order))  
       cout << " Order " << *data << endl;  
   else  
   if(data->isKindOf(class_Service))  
       cout << " Order " << *((Service*)data)->getArg(1)  
            << endl;  
   return YES;  
}

main(int,char**) 
{
   setRealTime(1);
   TopLevel* toplevel = new TopLevel; 
   ANIMATE_ON_WIDGET(toplevel,"topLevel-71");
   ANIMATE_CHILD(factory,"factory-57");
   START_ANIMATION; 
   toplevel->doIt(); 
   END_ANIMATION; 
   delete toplevel; 
   return 0; 
}
DEFINE_SIMPLE_CLASS(TopLevel,Object,1,NULL);
#define THIS TopLevel
#define BASE Object


TopLevel::TopLevel()
  : factory("Factory")
    // the constructor of factory is invoked, 
    // with name Factory

{
  TRACE_FUNC("TopLevel::TopLevel");
  box = new CppBox(topLevelWidget,"Box");
  startProd = new CppCommand(box,"StartProduction");
  startAss = new CppCommand(box,"StartAssistance");
  endWork = new CppCommand(box,"EndWork");

  factory.addCback(AnyCback,factoryChanged); 
     // any event is monitored 
}







void TopLevel::doIt()
{
  TRACE_FUNC("TopLevel::doIt");

  Process* doItProc = activeProcess();

  doItProc->attachTo(startProd,CommandPress);
  doItProc->attachTo(startAss,CommandPress);
  doItProc->attachTo(endWork,CommandPress);

  int prodCnt = 0, assCnt = 0;
  SELECT(doItProc)
    ACCEPT(CommandPress)
	Object* eventOwner = doItProc->eventOwner();
	if(eventOwner == startProd)
	{
		String name = form("Order%d",++prodCnt);
  		Order* o = new Order(name,OrderReceived,10);
  		factory.execProduction(o);  
		continue;
	}
	else
	if(eventOwner == startAss)
	{
		String name = form("Repair%d",++assCnt);
  		Order* o = new Order(name,OrderReceived,10);
  		factory.execAssistance(o);  
		continue;
	}
	else
	// (eventOwner == endWork)
  END_SELECT

  doItProc->detachFrom(startProd,CommandPress);
  doItProc->detachFrom(startAss,CommandPress);
  doItProc->detachFrom(endWork,CommandPress);

  topLevelWidget->down();
 
}




Object* TopLevel::editorTrace(String& s)
{
  if(s == "ev")
  {
	s = ev.printOnString();
	return (Object*)&ev;
  }
  else
  if(s == "factory")
  {
	s = factory.printOnString();
	return (Object*)&factory;
  }
  else
  if(s == "box")
  {
	s = box->printOnString();
	return (Object*)box;
  }
  else
  if(s == "startProd")
  {
	s = startProd->printOnString();
	return (Object*)startProd;
  }
  else
  if(s == "startAss")
  {
	s = startAss->printOnString();
	return (Object*)startAss;
  }
  else
  if(s == "endWork")
  {
	s = endWork->printOnString();
	return (Object*)endWork;
  }
  return nil;
}

/* End of File topLevel-72.C */

